/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["fbfwca.Clients"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["fbfwca.Clients"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dojox.widget.Standby");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.DropDownButton");
dojo.require("dijit.Menu");
dojo.require("dojo.cookie");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");	
dojo.require("fbfwca.Grid");
dojo.require("fbfwca.Common");
dojo.require("fbfwca.Formatters");
dojo.require("fbfwca.ajax");
dojo.require("fbfwca.Config");
dojo.require("fbfwca.ConfigWizard");
dojo.requireLocalization("nls", "general", null, "");
dojo.requireLocalization("nls_messages", "messages", null, "");

dojo.provide("fbfwca.Clients");

dojo.declare("fbfwca.Clients", null, {

	/**************************************************************************
	* Constructor
	**************************************************************************/
	constructor : function() {
		console.log("fbfwca.Clients(): in constructor");
		this.storeURL = "clients";
		this.mainPageId = "ClientsTableHolder";
		this.ConfigWizardId = 'ConfigWizardContainer';
		this.AssignGroupId = 'AssignGroupForm';
		this.SendScriptId = 'SendScriptForm';
		this.DeployUpdatesId = 'DeployUpdatesForm';
		this.ViewConfigId = 'ViewConfigForm';
		this.ViewActivityLogId = 'ViewActivityLogForm';
		this.connections = [];
		this.topics = [];
		this.healthGridObj = null;
		this.storageGridObj = null;
		this.deploymentGridObj = null;
		this.activityGridObj = null;
		this.healthGrid = null;
		this.storageGrid = null;
		this.deploymentGrid = null;
		this.activityGrid = null;
		this.currentGrid = null;
		this.currentGridObj = null;
		this.refreshHealthTable = false;
		this.refreshStorageTable = false;
		this.refreshDeployTable = false;
		this.configWizardObj = null;
		this.NLS = dojo.i18n.getLocalization("nls", "general");
		this.NLS_MESSAGES = dojo.i18n.getLocalization("nls_messages", "messages");
	
		dojo.byId("fatalLinkImg").alt = this.NLS.T_Fatal;
		dojo.byId("criticalLinkImg").alt = this.NLS.T_Critical;
		dojo.byId("normalLinkImg").alt = this.NLS.T_OK;
		dojo.byId("warningLinkImg").alt = this.NLS.T_Warning;
		dojo.byId("allLink").alt = this.NLS.T_View_all_clients;
		dojo.byId("fatalLinkImg").title = this.NLS.T_Fatal;
		dojo.byId("criticalLinkImg").title = this.NLS.T_Critical;
		dojo.byId("normalLinkImg").title = this.NLS.T_OK;
		dojo.byId("warningLinkImg").title = this.NLS.T_Warning;
		dojo.byId("allLink").title = this.NLS.T_View_all_clients;
		
		dojo.byId("viewConfigBreadcrumb").title = this.NLS.T_Clients;
		dojo.byId("viewActLogBreadcrumb").title = this.NLS.T_Clients;
		
		dijit.byId("HealthContentPane").attr("tooltip", this.NLS.T_Health);
		dijit.byId("HealthContentPane").attr("title", this.NLS.T_Health);
		dijit.byId("StorageContentPane").attr("tooltip", this.NLS.T_Storage);
		dijit.byId("StorageContentPane").attr("title", this.NLS.T_Storage);
		dijit.byId("DeploymentContentPane").attr("tooltip", this.NLS.T_Deployment);
		dijit.byId("DeploymentContentPane").attr("title", this.NLS.T_Deployment);

		// Get filter string input from the session bean
		this.filterStr = dojo.byId('filterStrId').title;
		
		// Determine initial query value based on this.filterStr
		this.initialQuery = "*";
		if ( this.filterStr == "fatalLink")
			this.initialQuery = 3;
		else if ( this.filterStr == "criticalLink")
			this.initialQuery = 2;
		else if ( this.filterStr == "warningLink")
			this.initialQuery = 1;
		else if ( this.filterStr == "normalLink")
			this.initialQuery = 0;

		// Subscribe to tab changes
		this.topics.push (dojo.subscribe("mainTabContainer-selectChild", this, function(page) {
				console.log("page=" + page.id);
				if (page.id == "HealthContentPane")
						this.InitHealthViewTable();
				else if (page.id == "StorageContentPane")
						this.CreateStorageGrid();
				else if (page.id == "DeploymentContentPane")
						this.CreateDeploymentGrid();
		}));
		
		dojo.style(this.mainPageId, "display", "block");
		this.initTabContainer();

	},

	/**************************************************************************
	* Initializes the tab container.
	**************************************************************************/
	initTabContainer : function () {
		console.log("initTabContainer");
		// Tab container persist attribute is set, initialize the page that was last.
		var selectedChild = dijit.byId("mainTabContainer").selectedChildWidget.id;
		if (selectedChild == "HealthContentPane")
			this.InitHealthViewTable();
		else if (selectedChild == "StorageContentPane")
			this.CreateStorageGrid();
		else
			this.CreateDeploymentGrid();
	},
	
	/**************************************************************************
	* Cleanup function
	**************************************************************************/
	destroy : function () {
  	// Destroy all subscriptions
  	dojo.forEach(this.topics, dojo.unsubscribe);
  	delete this.topics;
  	
  	// Destroy all event connections
		dojo.forEach(this.connections, dojo.disconnect);
  	delete this.connections;
	  	
		if (this.configWizardObj)
			delete this.configWizardObj;
		
		if (dijit.byId(this.AssignGroupId)) {
			console.log("destroy AssignGroupForm");
      dijit.byId(this.AssignGroupId).destroyRecursive();
    }
	
		if (dijit.byId(this.SendScriptId)) {
			console.log("destroy SendScriptForm");
      dijit.byId(this.SendScriptId).destroyRecursive();
    }

		if (dijit.byId(this.ViewConfigId)) {
			console.log("destroy ViewConfigForm");
    	dijit.byId(this.ViewConfigId).destroyRecursive();
  	}  

		if (dijit.byId(this.ViewActivityLogId)) {
			console.log("destroy ViewActivityLogForm");
     	dijit.byId(this.ViewActivityLogId).destroyRecursive();
  		delete this.activityGridObj;
   	}
    
    if (dijit.byId(this.DeployUpdatesId)) {
			console.log("destroy DeployUpdatesForm");
      dijit.byId(this.DeployUpdatesId).destroyRecursive();
    }  

		if (dijit.byId(this.mainPageId)) {
			console.log("destroy ClientsTableHolder");
			dijit.byId(this.mainPageId).destroyRecursive();
			delete this.healthGridObj;
  		delete this.storageGridObj;
  		delete this.deploymentGridObj;
		}  		

		delete this.storeURL;
		delete this.mainPageId;
		delete this.ConfigWizardId;
		delete this.AssignGroupId;
		delete this.SendScriptId;
		delete this.DeployUpdatesId;
		delete this.ViewConfigId;
		delete this.ViewActivityLogId;
		delete this.healthGrid;
		delete this.storageGrid;
		delete this.deploymentGrid;
		delete this.activityGrid;
		delete this.currentGrid;
		delete this.currentGridObj;
		delete this.NLS;
		delete this.NLS_MESSAGES;
			
 	},
 	
	/**************************************************************************
	* Initializes the Health view page by creating & loading the table.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	InitHealthViewTable : function () {
		console.log("InitHealthViewTable");
			
		if (this.healthGrid == null)
		{
	    var textAlign;
	    if(dojo.getComputedStyle(dojo.body()).direction == "rtl")
	      textAlign = "text-align:right;";
	    else
	      textAlign = "text-align:left;";
	      
			// Create the layout
			var layout = [
				{field: "_checked", name: "&nbsp;", width:"28px", editable:true, type:dojox.grid.cells.Bool,
						filter:false, styles: "text-align: center;" },
				{field: "status", name: this.NLS.T_Status, width:"60px", formatter:fbfwca.Formatters.StatusFormatter,
						filter:false, styles:"text-align: center;", sortDesc: true },
				{field: "name", name: this.NLS.T_Client_Name, width:"20%", cellClasses: "fauxLink", filter:true, styles:textAlign },
				{field: "group", name: this.NLS.T_Group, width:"20%", filter:true, styles:textAlign },
				{field: "adminfolder", name: this.NLS.T_Administration_Folder, width:"25%", filter:true, styles:textAlign },
				{field: "last_update", name: this.NLS.T_Last_Report, width:"35%", filter:false, 
						formatter:fbfwca.Formatters.DateFormatter, styles:textAlign }
			];

			// Create toolbar widgets
			var menu = new dijit.Menu();
			this.connections.push (dojo.connect(menu, 'onOpen', dojo.hitch(this, this.OnClick_HeathTableAction)));

			var item = new dijit.MenuItem({
					 label: this.NLS.T_VIEW_ACTLOG,
					 title: this.NLS.T_VIEW_ACTLOG,
					 iconClass: "logIcon",
					 id: "ViewActivityID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ShowActivityLog)));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 iconClass: "configureIcon",
					 label: this.NLS.T_CONFIGURE_ALERTS,
					 title: this.NLS.T_CONFIGURE_ALERTS
			});
			
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ConfigAlerts)));
			menu.addChild(item);
			menu.addChild(new dijit.MenuSeparator());

			item = new dijit.MenuItem({
					 label: this.NLS.T_ASSIGN_GROUP,
					 title: this.NLS.T_ASSIGN_GROUP,
					 iconClass: "folderIcon",
					 id: "h.AssignGroupID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ShowAssignGroupForm)));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_SEND_SCRIPT,
					 title: this.NLS.T_SEND_SCRIPT,
					 iconClass: "scriptIcon",
					 id: "h.SendScriptID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ShowSendScriptForm)));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_VIEW_CLIENT_CONFIG,
					 title: this.NLS.T_VIEW_CLIENT_CONFIG,
					 iconClass: "showpropertiesIcon",
					 id: "h.ViewClientConfigID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ViewClientConfig, "view")));
			menu.addChild(item);
			
			item = new dijit.MenuItem({
					 label: this.NLS.T_CREATE_GROUP_LIKE_CLIENT,
					 title: this.NLS.T_CREATE_GROUP_LIKE_CLIENT,
					 iconClass: "newIcon",
					 id: "h.CreateGroupID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ViewClientConfig, "create")));
			menu.addChild(item);

			var actionsDropDown = new dijit.form.DropDownButton({
						label: this.NLS.T_ACTIONS,
						title: this.NLS.T_ACTIONS,
						dropDown: menu
			});
			
			//var standby = fbfwca.Common.StandbyShow("mainTabContainer", null);
			// Create the grid
			var mask = "address|status|name|group|adminfolder|last_update";
			var gridParms = { storeURL : this.storeURL+"?mask="+mask,
								layout : layout,
								query : { status: this.initialQuery },
								sortAsc : true,
								autoHeight : false,
								actionsDropDown : actionsDropDown
							};

			this.healthGridObj = new fbfwca.Grid(gridParms, document.createElement('div'));
			dojo.byId("healthGridContainerNode").appendChild(this.healthGridObj.domNode);
			//this.healthGridObj.resize();
			this.healthGrid = this.healthGridObj.getTable();
			this.UpdateHealthStatus();
			this.refreshHealthTable = false;
			
			// Connect table default action
			this.connections.push (dojo.connect(this.healthGrid, "onCellClick", dojo.hitch(this, this.LaunchTableDefaultAction)));
		}
		else if (this.refreshHealthTable)
		{
			this.refreshHealthTable = false;
			this.healthGridObj.onRefresh();
		}
		else
		{
			this.healthGridObj.resize();
		}

		//fbfwca.Common.StandbyHide(standby);
		this.currentGridObj = this.healthGridObj;
		this.currentGrid = this.healthGrid;

	},

	/**************************************************************************
	* Updates the health status summary area.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	UpdateHealthStatus : function () {
		var total = 0;
		
		if ( this.healthGrid.store == undefined || this.healthGrid.store == null )
		{
			dojo.byId("fatalLink").innerHTML = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: 0 });
			dojo.byId("fatalLink").title = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: 0 });
			dojo.byId("fatalLink").alt = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: 0 });
			dojo.byId("criticalLink").innerHTML = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: 0 });
			dojo.byId("criticalLink").title = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: 0 });
			dojo.byId("criticalLink").alt = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: 0 });
			dojo.byId("normalLink").innerHTML = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: 0 });
			dojo.byId("normalLink").title = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: 0 });
			dojo.byId("normalLink").alt = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: 0 });
			dojo.byId("warningLink").innerHTML = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: 0 });
			dojo.byId("warningLink").title = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: 0 });
			dojo.byId("warningLink").alt = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: 0 });
			return;
		}
			
		this.healthGrid.store.fetch(
			{
				query: {status:3},
				onItem: function(item, request) {
						total++;
				}
			}
		);

		dojo.byId("fatalLink").innerHTML = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: total });
		dojo.byId("fatalLink").title = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: total });
		dojo.byId("fatalLink").alt = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: total });

		// Get # of critial
		total = 0;
		this.healthGrid.store.fetch(
			{
				query: {status:2},
				onItem: function(item, request) {
						total++;
				}
			}
		);
		dojo.byId("criticalLink").innerHTML = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: total });
		dojo.byId("criticalLink").title = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: total });
		dojo.byId("criticalLink").alt = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: total });
		
		// Get # of warning
		total = 0;
		this.healthGrid.store.fetch(
			{
				query: {status:1},
				onItem: function(item, request) {
						total++;
				}
			}
		);
		dojo.byId("warningLink").innerHTML = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: total });
		dojo.byId("warningLink").title = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: total });
		dojo.byId("warningLink").alt = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: total });

		// Get # of normal
		total = 0;
		if (this.healthGrid.store)
		{
			this.healthGrid.store.fetch(
				{
					query: {status:0},
					onItem: function(item, request) {
							total++;
					}
				}
			);
		}
		dojo.byId("normalLink").innerHTML = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: total });
		dojo.byId("normalLink").title = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: total });
		dojo.byId("normalLink").alt = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: total });
				
	},

	/**************************************************************************
	* Initializes the Storage view page by creating & loading the table.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	CreateStorageGrid : function () {
		console.log("CreateStorageGrid");
		
		if (this.storageGrid == null)
		{
	    var textAlign;
	    if(dojo.getComputedStyle(dojo.body()).direction == "rtl")
	      textAlign = "text-align:right;";
	    else
	      textAlign = "text-align:left;";
	      
			// Create the layout
			var layout = [
				{field: "_checked", name: "&nbsp;", width:"28px", editable:true, type:dojox.grid.cells.Bool,
						filter:false, styles: "text-align: center;" },
				{field: "status", name: this.NLS.T_Status, width:"60px", formatter:fbfwca.Formatters.StatusFormatter,
						filter:false, styles:"text-align: center;", sortDesc: true },
				{field: "name", name: this.NLS.T_Client_Name, width:"auto", cellClasses: "fauxLink", filter:true, styles:textAlign },
				{field: "group", name: this.NLS.T_Group, width:"auto", filter:true, styles:textAlign },
				{field: "local_storage_quota", name: this.NLS.T_LocalAssigned, width:"auto", formatter:fbfwca.Formatters.StorageValueFormatter,
						filter:false, styles:"text-align: center;" },
				{field: "local_storage_used", name: this.NLS.T_LocalUsed, width:"auto", formatter:fbfwca.Formatters.StorageValueFormatter,
						filter:false, styles:"text-align: center;" },
				{field: "local_storage_free", name: this.NLS.T_LocalFree, width:"auto", formatter:fbfwca.Formatters.StorageValueFormatter,
						filter:false, styles:"text-align: center;" },
				{field: "remote_storage_quota", name: this.NLS.T_RemoteAssigned, width:"auto", formatter:fbfwca.Formatters.StorageValueFormatter,
						filter:false, styles:"text-align: center;" },
				{field: "remote_storage_used", name: this.NLS.T_RemoteUsed, width:"auto", formatter:fbfwca.Formatters.StorageValueFormatter,
						filter:false, styles:"text-align: center;" },
				{field: "remote_storage_free", name: this.NLS.T_RemoteFree, width:"auto", formatter:fbfwca.Formatters.StorageValueFormatter,
						filter:false, styles:"text-align: center;" }
			];

			// Create toolbar widgets
			var menu = new dijit.Menu();
			this.connections.push (dojo.connect(menu, 'onOpen', dojo.hitch(this, this.OnClick_StgTableAction)));

			var item = new dijit.MenuItem({
					 label: this.NLS.T_ASSIGN_GROUP,
					 title: this.NLS.T_ASSIGN_GROUP,
					 iconClass: "folderIcon",
					 id: "s.AssignGroupID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ShowAssignGroupForm)));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_SEND_SCRIPT,
					 title: this.NLS.T_SEND_SCRIPT,
					 iconClass: "scriptIcon",
					 id: "s.SendScriptID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ShowSendScriptForm)));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_VIEW_CLIENT_CONFIG,
					 title: this.NLS.T_VIEW_CLIENT_CONFIG,
					 iconClass: "showpropertiesIcon",
					 id: "s.ViewClientConfigID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ViewClientConfig, "view")));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_CREATE_GROUP_LIKE_CLIENT,
					 title: this.NLS.T_CREATE_GROUP_LIKE_CLIENT,
					 iconClass: "newIcon",
					 id: "s.CreateGroupID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ViewClientConfig, "create")));
			menu.addChild(item);
			
			var actionsDropDown = new dijit.form.DropDownButton({
				label: this.NLS.T_ACTIONS,
				title: this.NLS.T_ACTIONS,
				dropDown: menu
			});
  
  			//var standby = fbfwca.Common.StandbyShow("mainTabContainer", null);
			// Create the grid
			var mask = "address|status|name|group|local_storage_quota|local_storage_used|local_storage_free|remote_storage_quota|remote_storage_used|remote_storage_free";
			var gridParms = { storeURL : this.storeURL+"?mask="+mask,
								layout : layout,
								query : { status: this.initialQuery },
								sortAsc : true,
								height : "400px",
								autoHeight : false,
								actionsDropDown : actionsDropDown
							};

			this.storageGridObj = new fbfwca.Grid(gridParms, document.createElement('div'));
			dojo.byId("storageGridContainerNode").appendChild(this.storageGridObj.domNode);
			this.storageGridObj.resize();
			this.storageGrid = this.storageGridObj.getTable();
			this.refreshStorageTable = false;
			
			// Connect table default action
			this.connections.push (dojo.connect(this.storageGrid, "onCellClick", dojo.hitch(this, this.LaunchTableDefaultAction)));
			this.connections.push (dojo.connect(this.storageGrid, "onCellMouseOver", this.ShowClientsGridTooltip));
			this.connections.push (dojo.connect(this.storageGrid, "onCellMouseOut", this.HideClientsGridTooltip));
		}
		else if (this.refreshStorageTable)
		{
			this.refreshStorageTable = false;
			this.storageGridObj.onRefresh();
		}
		else
		{
			this.storageGridObj.resize();
		}
				
		//fbfwca.Common.StandbyHide(standby);
		
		this.currentGridObj = this.storageGridObj;
		this.currentGrid = this.storageGrid;
	
	},

	/**************************************************************************
	* Initializes the Deployment view page by creating & loading the table.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	CreateDeploymentGrid : function () {
		console.log("CreateDeploymentGrid");
		if (this.deploymentGrid == null)
		{
	    var textAlign;
	    if(dojo.getComputedStyle(dojo.body()).direction == "rtl")
	      textAlign = "text-align:right;";
	    else
	      textAlign = "text-align:left;";
	      
			// Create the layout
			var layout = [
				{field: "_checked", name: "&nbsp;", width:"28px", editable:true, type:dojox.grid.cells.Bool,
						filter:false, styles: "text-align: center;" },
				{field: "status", name: this.NLS.T_Status, width:"60px", formatter:fbfwca.Formatters.StatusFormatter,
						filter:false, styles:"text-align: center;", sortDesc: true },
				{field: "name", name: this.NLS.T_Client_Name, width:"auto", filter:true, styles:textAlign },
				{field: "group", name: this.NLS.T_Group, width:"auto", filter:true, styles:textAlign },
				{field: "client_version", name: this.NLS.T_Client_Version, width:"auto", filter:true, styles:textAlign },
				{field: "client_os", name: this.NLS.T_Operating_System, width:"auto", filter:true, styles:textAlign },
				{field: "last_backup", name: this.NLS.T_Last_Full_Backup, width:"auto", 
						filter:false, formatter:fbfwca.Formatters.DateFormatter, styles:textAlign },
				{field: "backup_status", name: this.NLS.T_Full_Backup_Status, width:"auto", filter:false, hidden:'true' }

			];

			// Create toolbar widgets
			var menu = new dijit.Menu();
			this.connections.push (dojo.connect(menu, 'onOpen', dojo.hitch(this, this.OnClick_DeployTableAction)));

			var item = new dijit.MenuItem({
					 label: this.NLS.T_DEPLOY_SOFTWARE_UPDATES,
					 title: this.NLS.T_DEPLOY_SOFTWARE_UPDATES,
					 iconClass: "deployIcon",
					 id: "DeployUpdateID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ShowDeployUpdateForm)));
			menu.addChild(item);
			menu.addChild(new dijit.MenuSeparator());

			item = new dijit.MenuItem({
					 label: this.NLS.T_ASSIGN_GROUP,
					 title: this.NLS.T_ASSIGN_GROUP,
					 iconClass: "folderIcon",
					 id: "d.AssignGroupID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ShowAssignGroupForm)));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_SEND_SCRIPT,
					 title: this.NLS.T_SEND_SCRIPT,
					 iconClass: "scriptIcon",
					 id: "d.SendScriptID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ShowSendScriptForm)));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_VIEW_CLIENT_CONFIG,
					 title: this.NLS.T_VIEW_CLIENT_CONFIG,
					 iconClass: "showpropertiesIcon",
					 id: "d.ViewClientConfigID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ViewClientConfig, "view")));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_CREATE_GROUP_LIKE_CLIENT,
					 title: this.NLS.T_CREATE_GROUP_LIKE_CLIENT,
					 iconClass: "newIcon",
					 id: "d.CreateGroupID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ViewClientConfig, "create")));
			menu.addChild(item);
			
			var actionsDropDown = new dijit.form.DropDownButton({
				label: this.NLS.T_ACTIONS,
				title: this.NLS.T_ACTIONS,
				dropDown: menu
			});
  
  			//var standby = fbfwca.Common.StandbyShow("mainTabContainer", null);
			// Create the grid
			var mask = "address|status|name|group|client_version|client_os|last_backup";
			var gridParms = { storeURL : this.storeURL+"?mask="+mask,
								layout : layout,
								query : { status: this.initialQuery },
								sortAsc : true,
								height : "400px",
								autoHeight : false,
								actionsDropDown : actionsDropDown
							};

			this.deploymentGridObj = new fbfwca.Grid(gridParms, document.createElement('div'));
			dojo.byId("deployGridContainerNode").appendChild(this.deploymentGridObj.domNode);
			this.deploymentGridObj.resize();
			this.deploymentGrid = this.deploymentGridObj.getTable();
			this.refreshDeployTable = false;
		}
		else if (this.refreshDeployTable)
		{
			this.refreshDeployTable = false;
			this.deploymentGridObj.onRefresh();
		}
		else
		{
			this.deploymentGridObj.resize();
		}
				
		//fbfwca.Common.StandbyHide(standby);
		
		this.currentGridObj = this.deploymentGridObj;
		this.currentGrid = this.deploymentGrid;

	},
	

	/**************************************************************************
	* Initializes the Activity page by creating & loading the table.
	*
	* Parameter:
	*		store - json data 
	**************************************************************************/		
	LoadActivityPage : function (store) {
		console.log("LoadActivityPage");
			
		if ( this.activityGrid == null )
		{
			console.log("activityGrid does not exist");

	    var textAlign;
	    if(dojo.getComputedStyle(dojo.body()).direction == "rtl")
	      textAlign = "text-align:right;";
	    else
	      textAlign = "text-align:left;";
	      	
			var layout = [
				{field: 'uid', hidden:'true', filter:false },
				{field: 'date', name: this.NLS.T_Date, width:'20%', filter:false,
					formatter:fbfwca.Formatters.DateFormatter, styles:textAlign },
				{field: 'activity', name: this.NLS.T_Activity, width:'20%', filter:true, styles:textAlign },
				{field: 'result', name: this.NLS.T_Result, width:'20%', filter:true, styles:textAlign },
				{field: 'filename', name: this.NLS.T_File_Name, width:'40%', filter:true,
					formatter:fbfwca.Formatters.RemoveEscape, styles:textAlign }
			];

			// Create the grid
			//var store = fbfwca.ajax.getClientActivity(address);
			var gridParms = { //storeURL : storeURL,
								store : store,
								layout : layout,
								sortAsc : false,
								refreshButton : false,
								multiSelect : false,
								height : "500px",
								autoHeight : false
							};

			this.activityGridObj = new fbfwca.Grid(gridParms, document.createElement('div'));
			dojo.byId("activityGridContainerNode").appendChild(this.activityGridObj.domNode);
			this.activityGridObj.resize();
			this.activityGrid = this.activityGridObj.getTable();
		}
		else
		{
			console.log("activityGrid already exists");
			this.activityGridObj.setStore(store);
		}
			
	},

	/**************************************************************************
	* Handles default table action by invoking the appropriate function based
	* on which table view.
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	LaunchTableDefaultAction : function (e) {
		if (e.grid.getCell(e.cellIndex).field == "name")
		{
			if (e.grid == this.healthGrid)
				this.ShowActivityLog();
			else if (e.grid == this.storageGrid)
				this.ViewClientConfig("view");
			e.grid.selection.deselect(e.rowIndex);
		}
	},

	/**************************************************************************
	* Submits the config alert event to launch the Settings portlet.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ConfigAlerts : function (){
		dojo.byId('configAlertsAction').submit();
	},

	/**************************************************************************
	* Determines the selection from which table then shows the configuration
	* info for that client.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ViewClientConfig : function ( func ){
		console.log("ViewClientConfig");
		
		var item = this.currentGrid.selection.getFirstSelected();
		console.log("ViewClientConfig " + this.currentGrid.store.getValue(item, "status"));
		if ( this.currentGrid.store.getValue(item, "status") == 3 )
		{
			var	msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: this.NLS_MESSAGES.FBW1003E,
						 messageId: "FBW1003E",
						 type: "Error"});
			msgDlg.show();
		}
		else
		{
			if ( func == "view" )
				this.ShowConfigForm(this.currentGrid);
			else if ( func == "create" )
				this.ShowGroupWizard(this.currentGrid);
		}
	},
  
	/**************************************************************************
	* Handles status links in the health summary area.  Based on which link
	* was clicked, the table is refreshed to show only clients with the specified
	* status.
	*
	* Parameter:
	*		status - whic status
	**************************************************************************/		
	RefreshTable : function (status) {
		if ( status == 4 ) {
  		this.healthGrid.filter({status:'*'}, true);
		}
		else {
  		this.healthGrid.filter({status:status}, true);
		}
	},

	/**************************************************************************
	* Hide tooltip
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	HideClientsGridTooltip : function (e){
		dijit.hideTooltip(e.cellNode);
		dijit._masterTT._onDeck=null;
	},

	/**************************************************************************
	* Shows tooltip on storage fields.
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	ShowClientsGridTooltip : function (e) {
		var NLS = dojo.i18n.getLocalization("nls", "general");
		var row;
		var msg;
		if (e.grid.getCell(e.cellIndex).field == "local_storage_used")
		{
			row = e.grid.getItem(e.rowIndex);
			msg = dojo.number.format(e.grid.store.getValue(row, "local_storage_used", "0"), {})+ " " + NLS.T_bytes;
			dijit.showTooltip(msg, e.cellNode);
		}
		else if (e.grid.getCell(e.cellIndex).field == "local_storage_free")
		{
			row = e.grid.getItem(e.rowIndex);
			msg = dojo.number.format(e.grid.store.getValue(row, "local_storage_free", "0"), {})+ " " + NLS.T_bytes;
			dijit.showTooltip(msg, e.cellNode);
		}
		else if (e.grid.getCell(e.cellIndex).field == "local_storage_quota")
		{
			row = e.grid.getItem(e.rowIndex);
			msg = dojo.number.format(e.grid.store.getValue(row, "local_storage_quota", "0"), {})+ " " + NLS.T_bytes;
			dijit.showTooltip(msg, e.cellNode);
		}
		else if (e.grid.getCell(e.cellIndex).field == "remote_storage_used")
		{
			row = e.grid.getItem(e.rowIndex);
			msg = dojo.number.format(e.grid.store.getValue(row, "remote_storage_used", "0"), {})+ " " + NLS.T_bytes;
			dijit.showTooltip(msg, e.cellNode);
		}
		else if (e.grid.getCell(e.cellIndex).field == "remote_storage_free")
		{
			row = e.grid.getItem(e.rowIndex);
			msg = dojo.number.format(e.grid.store.getValue(row, "remote_storage_free", "0"), {})+ " " + NLS.T_bytes;
			dijit.showTooltip(msg, e.cellNode);
		}
		else if (e.grid.getCell(e.cellIndex).field == "remote_storage_quota")
		{
			row = e.grid.getItem(e.rowIndex);
			msg = dojo.number.format(e.grid.store.getValue(row, "remote_storage_quota", "0"), {})+ " " + NLS.T_bytes;
			dijit.showTooltip(msg, e.cellNode);
		}
	},

	/**************************************************************************
	* Initializes and shows the Group Configuration wizard.
	*
	* Parameter:
	*		grid - clients table grid
	**************************************************************************/		
	ShowGroupWizard : function (grid) {
		var data = null;
		
		if ( grid )
		{
			var item = grid.selection.getFirstSelected();
			var address = grid.store.getValue(item, "address");
			data = fbfwca.ajax.getClientConfiguration(address);
			if ( !data )
				return;
		}
		
		fbfwca.Common.ShowForm(this.ConfigWizardId, this.mainPageId);

		this.configWizardObj = new fbfwca.ConfigWizard({ name : null, table: this.currentGridObj, data: data,
																	pageid:this.mainPageId, parentDiv:this.ConfigWizardId }, 
																	document.createElement('div')); 
		dojo.byId(this.ConfigWizardId).appendChild(this.configWizardObj.domNode);
		this.configWizardObj.resize();
			
	},
	
	/**************************************************************************
	* Initializes and shows the Assign Group form.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ShowAssignGroupForm : function () {
		var widget = dijit.byId('SelectGroupFS');
		widget.store = fbfwca.ajax.getGroupSelectionList();
		dijit.byId("AssignGroupFormOK").attr("label", this.NLS.T_OK);
		dijit.byId("AssignGroupFormCancel").attr("label", this.NLS.T_CANCEL);
		dijit.byId("AssignGroupFormOK").attr("title", this.NLS.T_OK);
		dijit.byId("AssignGroupFormCancel").attr("title", this.NLS.T_CANCEL);
		dojo.byId('SelectGroupFS').value = this.NLS.T_Select_Group;
		this.appendSelectedClients(this.currentGrid, 'ClientsAssigned');
		fbfwca.Common.ShowForm(this.AssignGroupId, this.mainPageId);
	},

	/**************************************************************************
	* Initializes and shows the Send Script form.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ShowSendScriptForm : function () {
		
		var widget = dijit.byId('SelectScriptFS');
		widget.store = fbfwca.ajax.getScriptsList();
		dijit.byId("SendScriptFormOK").attr("label", this.NLS.T_OK);
		dijit.byId("SendScriptFormCancel").attr("label", this.NLS.T_CANCEL);

		dijit.byId("SendScriptFormOK").attr("title", this.NLS.T_OK);
		dijit.byId("SendScriptFormCancel").attr("title", this.NLS.T_CANCEL);

		dojo.byId('SelectScriptFS').value = this.NLS.T_Select_Script;
		this.appendSelectedClients(this.currentGrid, 'ClientsSent');

		fbfwca.Common.ShowForm(this.SendScriptId, this.mainPageId);
	},

	/**************************************************************************
	* Initializes and shows the client configuration.
	*
	* Parameter:
	*		grid - table object
	**************************************************************************/		
	ShowConfigForm : function (grid) {
		var br = "<br/>";
		var item = grid.selection.getFirstSelected();
		var name = grid.store.getValue(item, "name");
		var address = grid.store.getValue(item, "address");
		
		var data = fbfwca.ajax.getClientConfiguration(address);
		
		if ( data )
		{
		
			dojo.byId("ClientConfigCrumb").innerHTML = dojo.string.substitute(this.NLS.T_ClientConfig_Breadcrumb, { 0: name });
			dojo.byId("ClientConfigDesc").innerHTML = dojo.string.substitute(this.NLS.T_View_config_desc, { 0: name });

	    var msg = this.NLS.L_Backup_To_Label + data.localTarget + br;
	    msg += this.NLS.L_Vers_To_Keep_Label + data.localVersions + br;
	    msg += this.NLS.L_Backup_Max_Space_Label + fbfwca.Formatters.StorageValueFormatter(data.localPoolQuota) + br;
	    msg += this.NLS.L_Protection_Level_Label;
	    if (data.protection == 0)
	    	msg += this.NLS.T_None;
	   	else if (data.protection == 1)
	   		msg += this.NLS.T_Local_storage_only;
	   	else if (data.protection == 2)
	    	msg += this.NLS.T_Remote_storage_only;
	   	else if (data.protection == 3)
	   		msg += this.NLS.T_Local_and_remote;
	   		   	
	    dojo.byId("CdpData").innerHTML = msg;
	    
	    msg = this.NLS.L_Folders_Files_Label + data.includeList + br;
	    msg += this.NLS.L_Excl_Folders_Files_Label + data.excludeList + br;
	    msg += this.NLS.L_Vaulting_Label + data.vaultList;
	    dojo.byId("FtpData").innerHTML = msg;
	
	    msg = this.NLS.L_Email_Appl_Label + fbfwca.Config.getEmailAppFromIncludes(data.bitmapList, true) + br;
	    msg += this.NLS.L_Email_Folder_Label + data.bitmapList + br;
			var schedule = fbfwca.Config.targetBackupTimeToSchedule(data.scheduleTime, data.scheduleInterval);
			schedule.dayOfMonth++;
			schedule.dayOfWeek = this.convertDayOfWeek(schedule.dayOfWeek);
	    msg += this.NLS.L_How_Often_Label + fbfwca.Config.formatScheduleText(schedule);
	    dojo.byId("EmailData").innerHTML = msg;
	    msg = this.NLS.L_Backup_To_Label + data.remoteTarget + br;
	    msg += this.NLS.L_Vers_To_Keep_Label + data.remoteVersions + br;
	    msg += this.NLS.L_Backup_Max_Space_Label + fbfwca.Formatters.StorageValueFormatter(data.remotePoolQuota) + br;
	    msg += this.NLS.L_Advanced_Settings_Label;
	    var addComma = false;
		    
		  // If subfile threshold matches the magic number, subfile=no.  Subfile threshold can be 0.
			if (!data.encryptionOn && !data.compressionOn && fbfwca.Config.isThresholdValue(data.subfileThreshold))
				msg += this.NLS.T_None;
			else
			{
				if (data.encryptionOn)
				{
					msg += this.NLS.T_encrypt;
					addComma = true;
				}
		    
				if (data.compressionOn)
				{
					if (addComma)
						msg += ", ";
					msg += this.NLS.T_compression;
					addComma = true;
				}
				
				if ( !fbfwca.Config.isThresholdValue(data.subfileThreshold) )
				{
					if (addComma)
						msg += ", ";
					msg += this.NLS.T_subfile_threshold + fbfwca.Formatters.StorageValueFormatter(data.subfileThreshold);
				}
			}
	    dojo.byId("RemoteData").innerHTML = msg;
	
	    if (data.stealthMode == 0)
	    	msg = this.NLS.L_Msgs_Pop_Up_Label + this.NLS.T_enabled + br;
	    else
	    	msg = this.NLS.L_Msgs_Pop_Up_Label + this.NLS.T_disabled + br;
	    msg += this.NLS.L_Local_Max_Label + fbfwca.Formatters.StorageValueFormatter(data.localFileSizeLimit) + br;
	    msg += this.NLS.L_Remote_Max_Label + fbfwca.Formatters.StorageValueFormatter(data.remoteFileSizeLimit) + br;
	    msg += this.NLS.L_Max_Transfer_Rate_Label + fbfwca.Formatters.ThrottleValueFormatter(data.remoteThrottle) + br;
	    dojo.byId("PerfData").innerHTML = msg;
			fbfwca.Common.ShowForm(this.ViewConfigId, this.mainPageId);
		}
	},

	/**************************************************************************
	* Converts day of the week to a text string value.
	*
	* Parameter:
	*		none
	**************************************************************************/		
  convertDayOfWeek: function(day) {
		var DaysOfWeek = [this.NLS.T_Sunday, this.NLS.T_Monday, this.NLS.T_Tuesday, this.NLS.T_Wednesday, this.NLS.T_Thursday, this.NLS.T_Friday, this.NLS.T_Saturday ];
		
		return DaysOfWeek[day];
	},
	
	/**************************************************************************
	* Initializes and shows the Deploy Update form.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ShowDeployUpdateForm : function () {
		dijit.byId("DeployUpdatesFormOK").attr("label", this.NLS.T_OK);
		dijit.byId("DeployUpdatesFormCancel").attr("label", this.NLS.T_CANCEL);

		dijit.byId("DeployUpdatesFormOK").attr("title", this.NLS.T_OK);
		dijit.byId("DeployUpdatesFormCancel").attr("title", this.NLS.T_CANCEL);
		
		var response = fbfwca.ajax.getDeploymentPackages();
		var items = 0;
		response.fetch(
			{
				query: {name:"*"},
				onItem: function(item, request) {
						items++;
				}
			}
		);
		
		if ( items == 0)
		{
			var nlsMsg = dojo.string.substitute(this.NLS_MESSAGES.FBW1014E, { 0: fbfwca_deployPath });
			var	msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: nlsMsg,
						 messageId: "FBW1014E",
						 type: "Error"});
			msgDlg.show();		
			return;
		}

		var widget = dijit.byId('DeploymentPackageFS');
		widget.store = response;

		dojo.byId('DeploymentPackageFS').value = this.NLS.T_Select_Package;
  	this.appendSelectedClients(this.currentGrid, 'ClientsDeployed');
		
		fbfwca.Common.ShowForm(this.DeployUpdatesId, this.mainPageId);
	},

	/**************************************************************************
	* Appends to the specified div tag a list of selected clients.
	*
	* Parameter:
	*		grid - grid object
	*		divId - document ID of where text to be appended
	**************************************************************************/		
	appendSelectedClients : function (grid, divId) {
		var count = grid.selection.getSelectedCount();
		var i=0;
		var max=0;
		var item;
		var msg = '';

		if (count > 5)
			max = 5;
		else
			max = count;

		// Only 1 selected
		if ( max == 1)
		{
			item = grid.selection.getFirstSelected();
			msg += grid.store.getValue(item, "name") + ".";
		}
		
		// more than 1 selected
		else
		{		
			for (i=0; i<=max-2; i++)
			{
				if (i==0)
					item = grid.selection.getFirstSelected();
				else
				{
					msg += ", ";
					item = grid.selection.getNextSelected(item);
				}
				msg += grid.store.getValue(item, "name");
			}
			
			if ( count <= 5)
			{
				msg += this.NLS.T_and;
				item = grid.selection.getNextSelected(item);
				msg += grid.store.getValue(item, "name") + ".";
			}
			else
			{
				msg += ", ";
				item = grid.selection.getNextSelected(item);
				var more = count - max;
				msg += grid.store.getValue(item, "name") + this.NLS.T_and + more + this.NLS.T_more_clients;
			}
		}

		dojo.byId(divId).innerHTML = msg;
		
	},

	/**************************************************************************
	* Initializes and shows the Activity Log form.
	*
	**************************************************************************/		
	ShowActivityLog : function () {
		var address;
	
		//var standby = fbfwca.Common.StandbyShow("mainTabContainer", null);

		var item = this.healthGrid.selection.getFirstSelected();
		var name = this.healthGrid.store.getValue(item, "name");
		address = this.healthGrid.store.getValue(item, "address");
		dojo.byId("ActLogCrumb").innerHTML = dojo.string.substitute(this.NLS.T_Activity_Breadcrumb, { 0: name });
		
		var store = fbfwca.ajax.getClientActivity(address);
		if ( store )
		{
			fbfwca.Common.ShowForm(this.ViewActivityLogId, this.mainPageId);
			this.LoadActivityPage(store);
		}

		//fbfwca.Common.StandbyHide(standby);
	},

	/**************************************************************************
	* Handles button pressed on Assign Group form.
	*
	* Parameter:
	*		buttonId - which button was pressed (0=OK, 1=Cancel)
	**************************************************************************/		
	OnClick_AssignGroup : function (buttonId) {
	
		var widgets = ['SelectGroupFS'];

		// Cancel button
		if ( buttonId == 1 )
		{
			this.cleanup(widgets);
			this.HideForm(this.AssignGroupId, this.mainPageId);
			this.currentGridObj.resize();
			return;
		}
			
		// OK button
		var selection = dijit.byId('SelectGroupFS').attr('value');
		if ( selection == "" )
		{
			var	msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: this.NLS_MESSAGES.FBW1006E,
						 messageId: "FBW1006E",
						 type: "Error"});
			msgDlg.show();			
		}
		else
		{
			if ( selection == this.NLS.T_None )
				selection = "";
				
			var clients = new Array();
			var items = this.currentGrid.selection.getSelected();
			var i = 0;
			if (items.length) {
					dojo.forEach(items, function(selectedItem) {
							if (selectedItem != null) {
								clients[i] = "" + selectedItem.address;
								i++;
							}
					}); // end forEach
			}
			var response = fbfwca.ajax.assignClientGroup(clients, selection);	
			delete clients;
			if ( response == -1 )
				return;
			this.cleanup(widgets);
			this.HideForm(this.AssignGroupId, this.mainPageId);
			this.currentGridObj.onRefresh();
	
			// trigger other tables to refresh
			if ( this.currentGridObj == this.healthGridObj )
			{
				this.refreshStorageTable = true;
				this.refreshDeployTable = true;
			}
			else if ( this.currentGridObj == this.storageGridObj )
			{
				this.refreshHealthTable = true;
				this.refreshDeployTable = true;
			}
			else
			{
				this.refreshHealthTable = true;
				this.refreshStorageTable = true;
			}
		}

	},
	
	/**************************************************************************
	* Handles button pressed on Send Script form.
	*
	* Parameter:
	*		buttonId - which button was pressed (0=OK, 1=Cancel)
	**************************************************************************/		
	OnClick_SendScript : function (buttonId) {
		var widgets = ['SelectScriptFS'];
	
		// Cancel button
		if ( buttonId == 1 )
		{
			this.cleanup(widgets);
			this.HideForm(this.SendScriptId, this.mainPageId);
			this.currentGridObj.resize();
			return;
		}
			
		// OK button
		var selection = dijit.byId('SelectScriptFS').attr('value');
		if ( selection == "" )
		{
			var	msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: this.NLS_MESSAGES.FBW1007E,
						 messageId: "FBW1007E",
						 type: "Error"});
			msgDlg.show();			
		}
		else
		{
			var clients = new Array();
			var items = this.currentGrid.selection.getSelected();
			var i = 0;
			if (items.length) {
					dojo.forEach(items, function(selectedItem) {
							if (selectedItem != null) {
								clients[i] = "" + selectedItem.address;
								i++;
							}
					}); // end forEach
			}
			var response = fbfwca.ajax.sendScript(clients, selection);	
			delete clients;
			if ( response == -1 )
				return;
			this.currentGridObj.deselectAll();
			this.cleanup(widgets);
			this.HideForm(this.SendScriptId, this.mainPageId);
			this.currentGridObj.resize();

		}
	},

	/**************************************************************************
	* Handles button pressed on Deploy Updates form.
	*
	* Parameter:
	*		buttonId - which button was pressed (0=OK, 1=Cancel)
	**************************************************************************/		
	OnClick_DeployUpdates : function (buttonId) {
		var widgets = ['DeploymentPackageFS'];
		
		// Cancel button
		if ( buttonId == 1 )
		{
			this.cleanup(widgets);
			this.HideForm(this.DeployUpdatesId, this.mainPageId);
			this.currentGridObj.resize();
			return;
		}
			
		// OK button
		var selection = dijit.byId('DeploymentPackageFS').attr('displayedValue');
		if ( selection == "" || selection == this.NLS.T_Select_Package)
		{
			var	msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: this.NLS_MESSAGES.FBW1013E,
						 messageId: "FBW1013E",
						 type: "Error"});
			msgDlg.show();			
		}
		else
		{
			var clients = new Array();
			var items = this.currentGrid.selection.getSelected();
			var i = 0;
			if (items.length) {
					dojo.forEach(items, function(selectedItem) {
							if (selectedItem != null) {
								clients[i] = "" + selectedItem.address;
								i++;
							}
					}); // end forEach
			}
			var response = fbfwca.ajax.deployPackage(clients, selection);	
			delete clients;
			if ( response == -1 )
				return;
			this.currentGridObj.deselectAll();
			this.cleanup(widgets);
			this.HideForm(this.DeployUpdatesId, this.mainPageId);
			this.currentGridObj.resize();

		}
	},	
		
	/**************************************************************************
	* Enables or disables actions based on user's action selection.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	OnClick_HeathTableAction : function () {
		 var count = this.healthGrid.selection.getSelectedCount();
		
		 var CreateGroupAction = dijit.byId("h.CreateGroupID");
		 var AssignGroupAction = dijit.byId("h.AssignGroupID");
		 var SendScriptAction = dijit.byId("h.SendScriptID");
		 var ViewConfigAction = dijit.byId("h.ViewClientConfigID");
		 var ViewActivityAction = dijit.byId("ViewActivityID");

		 if ( count == 0 )
		 {
			CreateGroupAction.attr('disabled', true);
			AssignGroupAction.attr('disabled', true);
			SendScriptAction.attr('disabled', true);
			ViewConfigAction.attr('disabled', true);
			ViewActivityAction.attr('disabled', true);
		 }
		 else if ( count == 1 )
		 {
			CreateGroupAction.attr('disabled', false);
			AssignGroupAction.attr('disabled', false);
			SendScriptAction.attr('disabled', false);
			ViewConfigAction.attr('disabled', false);
			ViewActivityAction.attr('disabled', false);
		 }
		 else
		 {
			CreateGroupAction.attr('disabled', true);
			AssignGroupAction.attr('disabled', false);
			SendScriptAction.attr('disabled', false);
			ViewConfigAction.attr('disabled', true);
			ViewActivityAction.attr('disabled', true);
		 }
	},
	
	/**************************************************************************
	* Enables or disables actions based on user's action selection.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	OnClick_StgTableAction : function () {
		 var count = this.storageGrid.selection.getSelectedCount();
		
		 var CreateGroupAction = dijit.byId("s.CreateGroupID");
		 var AssignGroupAction = dijit.byId("s.AssignGroupID");
		 var SendScriptAction = dijit.byId("s.SendScriptID");
		 var ViewConfigAction = dijit.byId("s.ViewClientConfigID");

		 if ( count == 0 )
		 {
			CreateGroupAction.attr('disabled', true);
			AssignGroupAction.attr('disabled', true);
			SendScriptAction.attr('disabled', true);
			ViewConfigAction.attr('disabled', true);
		 }
		 else if ( count == 1 )
		 {
			CreateGroupAction.attr('disabled', false);
			AssignGroupAction.attr('disabled', false);
			SendScriptAction.attr('disabled', false);
			ViewConfigAction.attr('disabled', false);
		 }
		 else
		 {
			CreateGroupAction.attr('disabled', true);
			AssignGroupAction.attr('disabled', false);
			SendScriptAction.attr('disabled', false);
			ViewConfigAction.attr('disabled', true);
		 }
	},
		
	/**************************************************************************
	* Enables or disables actions based on user's action selection.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	OnClick_DeployTableAction : function () {
		 var count = this.deploymentGrid.selection.getSelectedCount();
		
		 var CreateGroupAction = dijit.byId("d.CreateGroupID");
		 var AssignGroupAction = dijit.byId("d.AssignGroupID");
		 var SendScriptAction = dijit.byId("d.SendScriptID");
		 var ViewConfigAction = dijit.byId("d.ViewClientConfigID");
		 var DeployUpdateAction = dijit.byId("DeployUpdateID");

		 if ( count == 0 )
		 {
			CreateGroupAction.attr('disabled', true);
			AssignGroupAction.attr('disabled', true);
			SendScriptAction.attr('disabled', true);
			ViewConfigAction.attr('disabled', true);
			DeployUpdateAction.attr('disabled', true);
		 }
		 else if ( count == 1 )
		 {
			CreateGroupAction.attr('disabled', false);
			AssignGroupAction.attr('disabled', false);
			SendScriptAction.attr('disabled', false);
			ViewConfigAction.attr('disabled', false);
			DeployUpdateAction.attr('disabled', false);
		 }
		 else
		 {
			CreateGroupAction.attr('disabled', true);
			AssignGroupAction.attr('disabled', false);
			SendScriptAction.attr('disabled', false);
			ViewConfigAction.attr('disabled', true);
			DeployUpdateAction.attr('disabled', false);
		 }
	},
	
	/**************************************************************************
	* Performs cleanup.
	*
	* Parameter:
	*		widgets - array of widgets names
	**************************************************************************/		
	cleanup : function (widgets) {
		
		if ( widgets == null )
			return;
		
		var i;	
		for (i=0; i < widgets.length; i++) {
			var widget = dijit.byId(widgets[i]);
			if (widget.attr('disabled') == false)
			{
				dijit.hideTooltip(widget.domNode);
				widget.reset();
			}
		}
	},

	/**************************************************************************
	* Returns an array of selected clients.  Each entry in the array is an
	* object of name and address.
	*
	* Parameter:
	*		none
	**************************************************************************/
 	getSelectedClients : function() {
 		var clients = new Array();
 		var count = this.currentGrid.selection.getSelectedCount();
 		console.log("getSelectedClients count=" + count);
 		if ( count > 0 )
 		{
 			var i;
 			var item = this.currentGrid.selection.getFirstSelected();
 			for (i=0; i<count; i++)
 			{
 				if ( item != null || item != undefined )
 				{
 					clients[i] = new Object();
					clients[i].name = "" + this.currentGrid.store.getValue(item, "name");
					clients[i].address = "" + this.currentGrid.store.getValue(item, "address");
					item = this.currentGrid.selection.getNextSelected(item);
				}
 			}
 		}
 		
 		console.log("getSelectedClients returns " + clients);
 		return clients;
 	},

	/**************************************************************************
	* Hides current form and shows the parent page.
	*
	* Parameter:
	*		formId - page id
	*		parentId - parent page id
	**************************************************************************/
 	HideForm : function (formId, parentId) {
	 	fbfwca.Common.HideForm(formId, parentId);
 	}
	  		
});

/*

<div class="graph">
    <strong class="bar" style="width: 40%;">40%</strong>
</div>

*/


}
