/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["fbfwca.Groups"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["fbfwca.Groups"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dojo.string");
dojo.require("dijit.form.DropDownButton");
dojo.require("dijit.Menu");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");	
dojo.require("fbfwca.Grid");
dojo.require("fbfwca.Common");
dojo.require("fbfwca.ConfigNB");
dojo.require("fbfwca.ConfigWizard");
dojo.require("fbfwca.ajax");
dojo.requireLocalization("nls", "general", null, "");
dojo.requireLocalization("nls_messages", "messages", null, "");

dojo.provide("fbfwca.Groups");

dojo.declare("fbfwca.Groups", null, {
	
	/**************************************************************************
	* Constructor
	**************************************************************************/
	constructor : function() {
		console.log("fbfwca.Groups(): in constructor");
		this.mainPageId = "MainTableHolder";
		this.ConfigWizardId = 'ConfigWizardContainer';
		this.ConfigNBId = 'ConfigNBContainer';
		this.connections = [];
		this.topics = [];
		this.gridObj = null;
		this.grid = null;
		this.configNBObj = null;
		this.configWizardObj = null;
		this.NLS = dojo.i18n.getLocalization("nls", "general");
		this.NLS_MESSAGES = dojo.i18n.getLocalization("nls_messages", "messages");
		this.InitGroupsTable();
  },

	/**************************************************************************
	* Cleanup function
	**************************************************************************/
	destroy : function () {
  	// Destroy all subscriptions
  	dojo.forEach(this.topics, dojo.unsubscribe);
  	delete this.topics;
  	
  	// Destroy all event connections
		dojo.forEach(this.connections, dojo.disconnect);
  	delete this.connections;

		if (dijit.byId(this.mainPageId)) {
			console.log("destroy MainTableHolder");
      dijit.byId(this.mainPageId).destroyRecursive();
	  	delete this.gridObj;
	  	delete this.grid;
    }  		

		delete this.mainPageId;
		delete this.ConfigWizardId;
		delete this.ConfigNBId;
  	delete this.configNBObj;
  	delete this.configWizardObj;
		delete this.NLS;
		delete this.NLS_MESSAGES;
 	},

	/**************************************************************************
	* Creates & loads the groups table.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	InitGroupsTable : function () {
      var textAlign;
      if(dojo.getComputedStyle(dojo.body()).direction == "rtl")
        textAlign = "text-align:right;";
      else
        textAlign = "text-align:left;";
        
			// Create the layout
			var layout = [
				{field: "_checked", name: "&nbsp;", width:"28px", editable:true, type:dojox.grid.cells.Bool,
						filter:false, styles: "text-align: center;" },
				{field: 'name', name: this.NLS.T_Name, width:'30%', cellClasses: "fauxLink", filter:true, styles:textAlign },
				{field: 'clients', name: this.NLS.T_Number_of_Clients, width:'20%', 
						filter:true, styles: "text-align:center;"},
				{field: 'description', name: this.NLS.T_Description, width:'50%', filter:true,
						formatter:fbfwca.Formatters.LongTextFormatter, styles:textAlign }
			];

			// Create toolbar widgets
			var	createButton = new ibm.tivoli.tip.dijit.TIPButton(
					{	label: this.NLS.T_CREATE_GROUP,
						showLabel: false, 
						iconClass: "newIcon"
					});
			this.connections.push (dojo.connect(createButton, 'onClick', dojo.hitch(this, this.PerformAction, "create")));

			var	deleteButton = new ibm.tivoli.tip.dijit.TIPButton(
					{	label: this.NLS.T_DELETE_GROUP,
						showLabel: false, 
						iconClass: "deleteIcon"
					});
			this.connections.push (dojo.connect(deleteButton, 'onClick', dojo.hitch(this, this.DeleteGroup)));

			var menu = new dijit.Menu();
			this.connections.push (dojo.connect(menu, 'onOpen', dojo.hitch(this, this.OnClick_TableAction)));

			var item = new dijit.MenuItem({
					 label: this.NLS.T_CREATE_GROUP,
					 title: this.NLS.T_CREATE_GROUP,
					 iconClass: "newIcon",
					 id: "CreateGroupID"
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.PerformAction, "create")));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_CREATE_LIKE_GROUP,
					 title: this.NLS.T_CREATE_LIKE_GROUP,
					 iconClass: "newIcon",
					 id: "CreateLikeID",
					 disabled: true
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.PerformAction, "createlike")));
			menu.addChild(item);
			
			item = new dijit.MenuItem({
					 label: this.NLS.T_MODIFY_GROUP,
					 title: this.NLS.T_MODIFY_GROUP,
					 iconClass: "editIcon",
					 id: "ModifyGroupID",
					 disabled: true
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.PerformAction, "modify")));
			menu.addChild(item);

			item = new dijit.MenuItem({
					 label: this.NLS.T_DELETE_GROUP,
					 title: this.NLS.T_DELETE_GROUP,
					 iconClass: "deleteIcon",
					 id: "DeleteGroupID",
					 disabled: true
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.DeleteGroup)));
			menu.addChild(item);

			//menu.addChild(new dijit.MenuSeparator());
                        
			var actionsDropDown = new dijit.form.DropDownButton({
		         label: this.NLS.T_ACTIONS,
		         title: this.NLS.T_ACTIONS,
		         id: "actionDropDown",
		         dropDown: menu
			});
  
			// Create the grid
			var gridParms = { storeURL : "groups",
												layout : layout,
												//id: fbfwca_root + "_GroupsTable",
												createButton : createButton,
												deleteButton : deleteButton,
												actionsDropDown : actionsDropDown
											};
											
			this.gridObj = new fbfwca.Grid(gridParms, document.createElement('div'));
			dojo.byId("gridContainerNode").appendChild(this.gridObj.domNode);
			this.gridObj.resize();
			this.grid = this.gridObj.getTable();
			
			// Connect table default action
			this.connections.push (dojo.connect(this.grid, 'onCellClick', dojo.hitch(this, this.LaunchTableDefaultAction)));
			this.connections.push (dojo.connect(this.grid, "onCellMouseOver", this.ShowGridTooltip));
			this.connections.push (dojo.connect(this.grid, "onCellMouseOut", this.HideGridTooltip));
	},

	/**************************************************************************
	* Resize table object
	**************************************************************************/		
	ResizeTable : function (){
		if (this.gridObj)
			this.gridObj.resize();
	},

	/**************************************************************************
	* Resize wizard object
	**************************************************************************/		
	ResizeWizard : function (){
		if (this.configWizardObj)
			this.configWizardObj.resize();
	},
	
	/**************************************************************************
	* Resize notebook object
	**************************************************************************/		
	ResizeNotebook : function (){
		if (this.configNBObj)
			this.configNBObj.resize();
	},
		
	/**************************************************************************
	* Hide tooltip
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	HideGridTooltip : function (e){
		dijit.hideTooltip(e.cellNode);
		dijit._masterTT._onDeck=null;
	},

	/**************************************************************************
	* Shows tooltip
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	ShowGridTooltip : function (e) {
		var row;
		if (e.grid.getCell(e.cellIndex).field == "description")
		{
			row = e.grid.getItem(e.rowIndex);
			dijit.showTooltip(e.grid.store.getValue(row, "description", "0"), e.cellNode);
		}
	},
	
	/**************************************************************************
	* Handles default table action.
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	LaunchTableDefaultAction : function (e) {
		if (e.grid.getCell(e.cellIndex).field == "name")
		{
			this.PerformAction('modify');
			e.grid.selection.deselect(e.rowIndex);
		}
	},

	/**************************************************************************
	* Handles table action.
	*
	* Parameter:
	*		action - which action
	**************************************************************************/		
	PerformAction : function (action){
		if (action.toLowerCase() == "create" )
		{
			this.ShowWizard("create");
		}
		else if (action.toLowerCase() == "createlike" )
		{
			this.ShowWizard("createlike");
		}
		else if (action.toLowerCase() == "modify" )
			this.ShowNotebook(null);
		else
			alert("Invalid action");
	},

	/**************************************************************************
	* Obtains data from the backend to populate the wizard.
	*
	* Parameter:
	*		action - create, createlike or cookie location name
	**************************************************************************/		
	ShowWizard : function (action) {
		var groupName;
		var data = null;
		
		if (action == 'createlike')
		{
			var item = this.grid.selection.getFirstSelected();
			groupName = this.grid.store.getValue(item, "name");
		}
		else if (action == 'create')
			groupName = "default";
		else
			groupName = null;
		
		fbfwca.Common.ShowForm(this.ConfigWizardId, this.mainPageId);

		this.configWizardObj = new fbfwca.ConfigWizard({ name : groupName, table: this.gridObj, data: null, 
																										pageid: this.mainPageId, parentDiv:this.ConfigWizardId }, 
																										document.createElement('div')); 
		dojo.byId(this.ConfigWizardId).appendChild(this.configWizardObj.domNode);
		this.configWizardObj.resize();

	},

	/**************************************************************************
	* Obtains data from the backend to populate the notebook.
	*
	* Parameter:
	*		location - from where
	**************************************************************************/		
	ShowNotebook : function (location) {
		var groupName;
		var data = null;
		
		var item = this.grid.selection.getFirstSelected();
		groupName = this.grid.store.getValue(item, "name");
					
		fbfwca.Common.ShowForm(this.ConfigNBId, this.mainPageId);

		this.configNBObj = new fbfwca.ConfigNB({ name : groupName, table: this.gridObj, data: null, 
																						pageid: this.mainPageId, parentDiv:this.ConfigNBId }, 
																						document.createElement('div')); 
		dojo.byId(this.ConfigNBId).appendChild(this.configNBObj.domNode);
		this.configNBObj.resize();
		
	},

	/**************************************************************************
	* Issues a confirm message for the deletion.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	DeleteGroup : function () {
		var msgDlg;
		if ( this.grid.selection.getSelectedCount() == 0 )
		{
				msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: this.NLS_MESSAGES.FBW1002E,
						 messageId: "FBW1002E",
						 type: "Error"});
		}
		else
		{
				var buttons = [this.NLS.T_OK, this.NLS.T_CANCEL];
				msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: this.NLS_MESSAGES.FBW1001C,
						 messageId: "FBW1001C",
						 type: "Confirm",
						 callback: this.DeleteGroupCallback,
						 callbackParms: {grid: this.grid, gridObj: this.gridObj},
						 buttons: buttons});
		}
		msgDlg.show();
	},

	/**************************************************************************
	* Delete call back.  Called by TIPMessageDialog.
	*
	* Parameter:
	*		buttonPressedId - button pressed
	*		messageId - message ID
	*		checked - show checked box check
	*		parms - {grid: this.grid, gridObj: this.gridObj}
	**************************************************************************/		
	DeleteGroupCallback : function (buttonPressedId, messageId, checked, parms) {

		if (buttonPressedId == 0)
		{
		  var count = 0;
	    parms.grid.store.fetch(
		  {
			  query: {_checked:true},
			  onItem: function(item, request) {
					  console.log("DeleteGroupCallback: " + item.name);
					  fbfwca.ajax.deleteGroup(item.name);
					  parms.grid.store.deleteItem(item);
					  count++;
			  }
		  });
		  parms.grid.store.save();
		  parms.grid.sort();
		  parms.gridObj.updateFooter(parms.grid.rowCount-count, 0);
		}
	},
	
	/**************************************************************************
	* Enables or disables actions based on user's action selection.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	OnClick_TableAction : function () {
		var count = this.grid.selection.getSelectedCount();
		
		var CreateAction = dijit.byId("CreateLikeID");
		var DeleteAction = dijit.byId("DeleteGroupID");
		var ModifyAction = dijit.byId("ModifyGroupID");

		if ( count == 0 )
		{
			CreateAction.attr('disabled', true);
			DeleteAction.attr('disabled', true);
			ModifyAction.attr('disabled', true);
		}
		else if ( count == 1 )
		{
			CreateAction.attr('disabled', false);
			DeleteAction.attr('disabled', false);
			ModifyAction.attr('disabled', false);
		}
		else
		{
			CreateAction.attr('disabled', true);
			DeleteAction.attr('disabled', false);
			ModifyAction.attr('disabled', true);
		}
	}

});

}
