/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["fbfwca.Health"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["fbfwca.Health"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dojox.widget.Standby");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");		
dojo.require("fbfwca.Grid");
dojo.require("fbfwca.Common");
dojo.require("fbfwca.Formatters");
dojo.require("fbfwca.ajax");
dojo.requireLocalization("nls", "general", null, "");
dojo.requireLocalization("nls_messages", "messages", null, "");

dojo.provide("fbfwca.Health");

dojo.declare("fbfwca.Health", null, {

	/**************************************************************************
	* Constructor
	**************************************************************************/
	constructor : function() {
		console.log("fbfwca.Health(): in constructor");
		this.mainPageId = 'MainPageHolder';
		this.ViewAuditLogId = 'ViewAuditLogForm';
		this.connections = [];
		this.topics = [];
		this.gridObj = null;
		this.grid = null;
		this.auditlogObj = null;
		
		this.NLS = dojo.i18n.getLocalization("nls", "general");
		this.NLS_MESSAGES = dojo.i18n.getLocalization("nls_messages", "messages");

		dojo.byId("fatalLinkImg").alt = this.NLS.T_Fatal;
		dojo.byId("criticalLinkImg").alt = this.NLS.T_Critical;
		dojo.byId("normalLinkImg").alt = this.NLS.T_OK;
		dojo.byId("warningLinkImg").alt = this.NLS.T_Warning;
		dojo.byId("allLink").alt = this.NLS.T_View_all_clients;
		dojo.byId("fatalLinkImg").title = this.NLS.T_Fatal;
		dojo.byId("criticalLinkImg").title = this.NLS.T_Critical;
		dojo.byId("normalLinkImg").title = this.NLS.T_OK;
		dojo.byId("warningLinkImg").title = this.NLS.T_Warning;
		dojo.byId("allLink").title = this.NLS.T_View_all_clients;
		dojo.byId("auditlogLink").title = this.NLS.T_More;
		
		dojo.byId("auditLogBreadcrumb").title = this.NLS.T_Health_Monitor;

		fbfwca.Common.ShowForm(this.mainPageId, this.ViewAuditLogId);
		this.InitClientsPod();
		this.InitAuditPod();
		this.InitAlertsPod();
  },

	/**************************************************************************
	* Cleanup function
	**************************************************************************/
	destroy : function () {
      	// Destroy all subscriptions
      	dojo.forEach(this.topics, dojo.unsubscribe);
      	delete this.topics;
      	
      	// Destroy all event connections
    	dojo.forEach(this.connections, dojo.disconnect);
      	delete this.connections;
      	
   		if (dijit.byId(this.ViewAuditLogId)) {
   			console.log("destroy ViewAuditLogForm");
   				if (this.auditlogObj == null)
            dijit.byId(this.ViewAuditLogId).destroy();
          else
            dijit.byId(this.ViewAuditLogId).destroyRecursive();
      			delete this.auditlogObj;
        }
          
   		if (dijit.byId(this.mainPageId)) {
   			console.log("destroy MainPageHolder");
            dijit.byId(this.mainPageId).destroyRecursive();
      		delete this.gridObj;
      		delete this.grid;

        }

		delete this.mainPageId;
		delete this.ViewAuditLogId;
		delete this.NLS;
		delete this.NLS_MESSAGES;
 	},
	  
	/**************************************************************************
	* Initializes the health status summary.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	InitClientsPod : function (){
		var response = fbfwca.ajax.getClientsHealthSummary();
		
		if ( response == undefined || response == null )
		{
			dojo.byId("fatalLink").innerHTML = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: 0 });
			dojo.byId("fatalLink").title = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: 0 });
			dojo.byId("fatalLink").alt = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: 0 });
			dojo.byId("criticalLink").innerHTML = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: 0 });
			dojo.byId("criticalLink").title = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: 0 });
			dojo.byId("criticalLink").alt = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: 0 });
			dojo.byId("normalLink").innerHTML = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: 0 });
			dojo.byId("normalLink").title = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: 0 });
			dojo.byId("normalLink").alt = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: 0 });
			dojo.byId("warningLink").innerHTML = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: 0 });
			dojo.byId("warningLink").title = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: 0 });
			dojo.byId("warningLink").alt = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: 0 });

		}
		else
		{
			dojo.byId("fatalLink").innerHTML = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: response.missing });
			dojo.byId("fatalLink").title = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: response.missing });
			dojo.byId("fatalLink").alt = dojo.string.substitute(this.NLS.T_FATAL_TEXT, { 0: response.missing });
			dojo.byId("criticalLink").innerHTML = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: response.critical });
			dojo.byId("criticalLink").title = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: response.critical });
			dojo.byId("criticalLink").alt = dojo.string.substitute(this.NLS.T_CRITICAL_TEXT, { 0: response.critical });
			dojo.byId("warningLink").innerHTML = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: response.warning });
			dojo.byId("warningLink").title = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: response.warning });
			dojo.byId("warningLink").alt = dojo.string.substitute(this.NLS.T_WARNING_TEXT, { 0: response.warning });
			dojo.byId("normalLink").innerHTML = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: response.normal });
			dojo.byId("normalLink").title = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: response.normal });
			dojo.byId("normalLink").alt = dojo.string.substitute(this.NLS.T_NORMAL_TEXT, { 0: response.normal });
		}
	},

	/**************************************************************************
	* Initializes the audit log summary.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	InitAuditPod : function (){
		var entries = "";
		var response = fbfwca.ajax.getAuditArray(5);
		var i;
		for (i=0; i< response.items.length; i++)
		{
			entries += fbfwca.Formatters.DateFormatter(response.items[i].timestamp) + " - ";
			entries += response.items[i].msgtext + "<br/>";
		}
		
		dojo.byId('auditlogEntries').innerHTML = entries;

	},
	
	/**************************************************************************
	* Creates & loads the alerts table.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	InitAlertsPod : function (){
	  if (this.gridObj == null && document.getElementById("AlertsContentPane").style.display != "none")
	  {
      var textAlign;
      if(dojo.getComputedStyle(dojo.body()).direction == "rtl")
        textAlign = "text-align:right;";
      else
        textAlign = "text-align:left;";
      
	    var layout = [
		      {field: "_checked", name: "&nbsp;", width:"28px", editable:true, type:dojox.grid.cells.Bool,
					filter:false, styles: "text-align: center;" },
          {field: 'status', name: this.NLS.T_Status, width:'60px', formatter:fbfwca.Formatters.StatusFormatter,
                    filter:false, styles:"text-align: center;", sortDesc: true },
          {field: 'timestamp', name: this.NLS.T_Timestamp, width:'20%', filter:false, 
          		formatter:fbfwca.Formatters.DateFormatter, styles:textAlign },
          {field: 'client', name: this.NLS.T_Client_Address, filter:true, width:'40%', styles:textAlign },
          {field: 'msgtext', name: this.NLS.T_Message_Text, filter:true, width:'40%', 
          		formatter:fbfwca.Formatters.TextFormatter, styles:textAlign }
      ];

			// Create toolbar widgets
			var	deleteButton = new ibm.tivoli.tip.dijit.TIPButton(
					{	label: this.NLS.T_Delete_an_Alert,
						showLabel: false, 
						iconClass: "deleteIcon"
					});
			this.connections.push (dojo.connect(deleteButton, 'onClick', dojo.hitch(this, this.DeleteAlert)));
		
			var menu = new dijit.Menu();
			this.connections.push (dojo.connect(menu, 'onOpen', dojo.hitch(this, this.OnClick_TableAction)));

			var item = new dijit.MenuItem({
					 label: this.NLS.T_Delete_an_Alert,
					 title: this.NLS.T_Delete_an_Alert,
					 iconClass: "deleteIcon",
					 id: "DeleteAlertID",
					 disabled: true
			});
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.DeleteAlert)));
			menu.addChild(item);
		
			item = new dijit.MenuItem({
					 iconClass: "configureIcon",
					 label: this.NLS.T_CONFIGURE_ALERTS,
					 title: this.NLS.T_CONFIGURE_ALERTS
			});
			
			this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.ConfigAlerts)));
			menu.addChild(item);

			var actionsDropDown = new dijit.form.DropDownButton({
						label: this.NLS.T_ACTIONS,
						title: this.NLS.T_ACTIONS,
						dropDown: menu
			});
			
			//var standby = fbfwca.Common.StandbyShow("HealthPageContentPane", null);

			// Create the grid
			var gridParms = { storeURL : "healthalerts",
							layout : layout,
							sortIndex : 2,
							sortAsc : false,
							deleteButton : deleteButton,
							actionsDropDown : actionsDropDown,
							height : "200px",
							autoHeight : false
						};

			this.gridObj = new fbfwca.Grid(gridParms, document.createElement('div'));
			dojo.byId("alertgridContainer").appendChild(this.gridObj.domNode);
			this.gridObj.resize();
			this.grid = this.gridObj.getTable();

			this.connections.push (dojo.connect(this.grid, "onCellMouseOver", this.ShowGridTooltip));
			this.connections.push (dojo.connect(this.grid, "onCellMouseOut", this.HideGridTooltip));		

			//fbfwca.Common.StandbyHide(standby);
	   }
	},

	/**************************************************************************
	* Hide tooltip
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	HideGridTooltip : function (e){
		dijit.hideTooltip(e.cellNode);
		dijit._masterTT._onDeck=null;
	},

	/**************************************************************************
	* Shows tooltip
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	ShowGridTooltip : function (e) {
		var row;
		if (e.grid.getCell(e.cellIndex).field == "msgtext")
		{
			row = e.grid.getItem(e.rowIndex);
			dijit.showTooltip(e.grid.store.getValue(row, "msgtext", "0"), e.cellNode);
		}
	},
	
	/**************************************************************************
	* Submits the config alert event to launch the Settings portlet.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ConfigAlerts : function (){
		console.log("Health: enter ConfigAlerts");
		// Only perform submit if we are on the main page
		if (dojo.byId("MainPageHolder").style.display != "none" )
	    {
			console.log("ConfigAlerts: calling submit");
			dojo.byId('configAlertsAction').disabled = false;
			dojo.byId('configAlertsAction').submit();
			dojo.byId('configAlertsAction').disabled = true;
		}
	},
		
	/**************************************************************************
	* Shows the audit log page.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ShowAuditLog : function () {
		fbfwca.Common.ShowForm(this.ViewAuditLogId, this.mainPageId);
		this.LoadAuditLog();
	},

	/**************************************************************************
	* Creates & loads the audit log table.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	LoadAuditLog : function () {
		//var standby = fbfwca.Common.StandbyShow("AuditLogContentPane", null);
		if ( this.auditlogObj == null )
		{
			console.log("auditLog does not exist");
			// Create the layout
      var textAlign;
      if(dojo.getComputedStyle(dojo.body()).direction == "rtl")
        textAlign = "text-align:right;";
      else
        textAlign = "text-align:left;";
      
      var layout = [
				{field: 'uid', hidden:'true', filter:false },
				{field: 'timestamp', name: this.NLS.T_Timestamp, width:'20%', filter:false,
						formatter:fbfwca.Formatters.DateFormatter, styles:textAlign },
				{field: 'msgtext', name: this.NLS.T_Message_Text, width:'80%', filter:true, styles:textAlign }
			];

			// Create the grid
			var gridParms = { storeURL : "audit",
							layout : layout,
							sortAsc : false,
							multiSelect : false,
							height : "500px",
							autoHeight : false							
						};
											
			this.auditlogObj = new fbfwca.Grid(gridParms, document.createElement('div'));
			dojo.byId("auditGridContainer").appendChild(this.auditlogObj.domNode);
			this.auditlogObj.resize();
		}
	
		//fbfwca.Common.StandbyHide(standby);
	},
	
	/**************************************************************************
	* Handles button pressed on Audit Log page.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	OnClick_AuditLog : function () {
	    fbfwca.Common.HideForm(this.ViewAuditLogId, this.mainPageId);
	    if ( this.auditlogObj )
	    {
				this.auditlogObj.destroy();
				this.auditlogObj = null;
				var el = document.getElementById("auditGridContainer");
				if ( el ) {
					while(el.hasChildNodes()){
						el.removeChild(el.childNodes[0]);
					}
				}
			}
      	
			var pane = document.getElementById("AlertsContentPane");
			console.log("OnClick_AuditLog: pane.style.display = "+pane.style.display);
			if ( pane.style.display != "none" ){
    				this.gridObj.onRefresh();
			}
			else {
				// if the pane is none, destroy the grid, otherwise it cannot display when the pane become block
				if ( this.gridObj ) {
  				this.gridObj.destroy();
					this.gridObj = null;
					var el = document.getElementById("alertgridContainer");
					if ( el ) {
						while(el.hasChildNodes()){
							el.removeChild(el.childNodes[0]);
						}
					}
				}
			}

	},
	/**************************************************************************
	* Handle resize the alerts
	*
	* Parameter:
	*		none
	**************************************************************************/
	resizeAlerts : function  () {
		console.log("Health: enter resizeAlerts");
		var pane = document.getElementById("AlertsContentPane");
		console.log("resizeAlerts: pane.style.display = "+pane.style.display);
		if ( pane.style.display == "none" ) {
			// if the pane is none, destroy the grid, otherwise it cannot display when the pane become block
			if ( this.gridObj ) {
				this.gridObj.destroy();
				this.gridObj = null;
				var el = document.getElementById("alertgridContainer");
				if ( el ) {
					while(el.hasChildNodes()){
						el.removeChild(el.childNodes[0]);
					}
				}
			}
		}
		else if (this.gridObj) {
			console.log("Health: resize Alerts table");
			this.gridObj.resize();
		}
	},

	/**************************************************************************
	* Handle resize the audit log table
	*
	* Parameter:
	*		none
	**************************************************************************/
	resizeAuditLog : function  () {
		if (this.auditlogObj) {
			console.log("Health: resize AuditLog table");
			this.auditlogObj.resize();
		}
	},

	/**************************************************************************
	* Issues a confirm message for the deletion.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	DeleteAlert : function () {
		var msgDlg;
		if ( this.grid.selection.getSelectedCount() == 0 )
		{
				msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: this.NLS_MESSAGES.FBW1002E,
						 messageId: "FBW1002E",
						 type: "Error"});
		}
		else
		{
				var buttons = [this.NLS.T_OK, this.NLS.T_CANCEL];
				msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: this.NLS_MESSAGES.FBW1001C,
						 messageId: "FBW1001C",
						 type: "Confirm",
						 callback: this.DeleteAlertCallback,
						 callbackParms: {grid: this.grid, gridObj: this.gridObj},
						 buttons: buttons});
		}
		msgDlg.show();
    },

	/**************************************************************************
	* Delete call back.  Called by TIPMessageDialog.
	*
	* Parameter:
	*		buttonPressedId - button pressed
	*		messageId - message ID
	*		checked - show checked box check
	*		parms - {grid: this.grid, gridObj: this.gridObj}
	**************************************************************************/		
	DeleteAlertCallback : function (buttonPressedId, messageId, checked, parms) {
		if (buttonPressedId == 0) {

        var alerts = new Array();
        var i = 0;
	    parms.grid.store.fetch(
		  {
			  query: {_checked:true},
			  onItem: function(item, request) {
					  alerts[i] = ""+item.id;
					  i++;
					  parms.grid.store.deleteItem(item);
					  if (i > 5000) {
                	    fbfwca.ajax.deleteAlertNotifications(alerts);
                	    alerts = new Array();
                	    i = 0;
					  }
			  }
		  });
	    if (alerts.length > 0) {
    	    fbfwca.ajax.deleteAlertNotifications(alerts);
	    }
	    parms.gridObj.onRefresh();
	    }
	},
	
	/**************************************************************************
	* Enables or disables actions based on user's action selection.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	OnClick_TableAction : function () {
		 var count = this.grid.selection.getSelectedCount();	
		 if ( count == 0 )
			dijit.byId("DeleteAlertID").attr('disabled', true);
		 else
			dijit.byId("DeleteAlertID").attr('disabled', false);
	} 

});

}
