/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["fbfwca.ajax"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["fbfwca.ajax"] = true;
dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.requireLocalization("nls", "general", null, "");
dojo.requireLocalization("nls_messages", "messages", null, "");
dojo.provide("fbfwca.ajax");

fbfwca.ajax = {

    AJAX_SERVLET: "/AjaxServlet",

    errorHandler: function(msg) {

        var NLS_MESSAGES = dojo.i18n.getLocalization("nls_messages", "messages");
        var nlsMsg = dojo.string.substitute(NLS_MESSAGES.FBW1004E, { 0: msg });
        //var msgId = obj.msg.split(" ",1);

        var msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
							{ message: nlsMsg,
							    messageId: "FBW10004E",
							    type: "Error"
							});
        msgDlg.show();
    },

    responseHandler: function(obj) {
        if (obj.result != 0 || obj.msg != "") {
            var msgType = "";
            var msgId = "" + obj.msg.split(" ", 1);
            var type = msgId.charAt(msgId.length - 1);
            if (type == "I")
                msgType = "Info";
            else if (type == "W")
                msgType = "Warning";
            else
                msgType = "Error";

            var nlsMsg = "" + obj.msg.substring(msgId.length + 1, obj.msg.length - 1);

            var msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
							    { message: nlsMsg,
							        messageId: msgId,
							        type: msgType
							    });
            msgDlg.show();
        }
    },
    addRefreshSuffix: function(uri) {
        if (uri.indexOf("?") != -1) {
            uri += "&refresh=" + (new Date()).getTime();
        }
        else {
            uri += "?refresh=" + (new Date()).getTime();
        }
        return uri;
    },

    getJsonWriteStore: function(name) {
        console.log("servlet:" + fbfwca.ajax.AJAX_SERVLET);
        console.log("getJsonWriteStore: ", name);
        var jsonstore;
        dojo.xhrGet({
            //	        url: root + fbfwca.ajax.AJAX_SERVLET + "/" + name,  //the relative URL
            //	        url: fbfwca_getRoot()+ fbfwca.ajax.AJAX_SERVLET + "/" + name,  //the relative URL
            url: fbfwca.ajax.addRefreshSuffix(fbfwca_root + fbfwca.ajax.AJAX_SERVLET + "/" + name),  //the relative URL
            sync: true,
            //handleAs: "json",
            load: function(response, ioArgs) {
                console.log("response \n", response);
                var obj = dojo.fromJson(response);
                if (obj.result == 0) {
                    jsonstore = new dojo.data.ItemFileWriteStore({ data: obj.data });
                }
                fbfwca.ajax.responseHandler(obj);
                return response; //always return the response back
            },

            // Run this function if the request is not successful
            error: function(response, ioArgs) {
                console.log("failed xhrGet", response, ioArgs);
                fbfwca.ajax.errorHandler(response);
                return response; //always return the response back
            }
        });
        return jsonstore;
    },

    getJsonReadStore: function(name) {
        console.log("servlet:" + fbfwca.ajax.AJAX_SERVLET);
        console.log("getJsonReadStore: ", name);
        var jsonstore;
        dojo.xhrGet({
            //	        url: fbfwca_getRoot()+ fbfwca.ajax.AJAX_SERVLET + "/" + name,  //the relative URL
            url: fbfwca.ajax.addRefreshSuffix(fbfwca_root + fbfwca.ajax.AJAX_SERVLET + "/" + name),  //the relative URL
            sync: true,
            load: function(response, ioArgs) {
                console.log("response \n", response);
                var obj = dojo.fromJson(response);
                console.log("result: " + obj.result);
                if (obj.result == 0) {
                    jsonstore = new dojo.data.ItemFileReadStore({ data: obj.data });
                }
                fbfwca.ajax.responseHandler(obj);
                return response; //always return the response back
            },

            // Run this function if the request is not successful
            error: function(response, ioArgs) {
                console.log("failed xhrGet", response, ioArgs);
                fbfwca.ajax.errorHandler(response);
                return response; //always return the response back
            }
        });
        return jsonstore;
    },

    getJsonObject: function(name) {
        console.log("servlet:" + fbfwca.ajax.AJAX_SERVLET);
        console.log("getJsonWriteStore: ", name);
        var jsonObject = null;
        dojo.xhrGet({
            url: fbfwca.ajax.addRefreshSuffix(fbfwca_root + fbfwca.ajax.AJAX_SERVLET + "/" + name),  //the relative URL
            sync: true,
            load: function(response, ioArgs) {
                console.log("response \n", response);
                var obj = dojo.fromJson(response);
                if (obj.result == 0) {
                    jsonObject = obj.data;
                }
                fbfwca.ajax.responseHandler(obj);
                return response; //always return the response back
            },

            // Run this function if the request is not successful
            error: function(response, ioArgs) {
                console.log("failed xhrGet", response, ioArgs);
                fbfwca.ajax.errorHandler(response);
                return response; //always return the response back
            }
        });
        return jsonObject;
    },


    getJsonWriteStore2: function(name, content) {
        console.log("servlet:" + fbfwca.ajax.AJAX_SERVLET);
        console.log("getJsonWriteStore: ", name);
        var jsonstore;
        dojo.xhrGet({
            //	        url: root + fbfwca.ajax.AJAX_SERVLET + "/" + name,  //the relative URL
            //	        url: fbfwca_getRoot()+ fbfwca.ajax.AJAX_SERVLET + "/" + name,  //the relative URL
        url: fbfwca.ajax.addRefreshSuffix(fbfwca_root + fbfwca.ajax.AJAX_SERVLET + "/" + name),  //the relative URL
            content: content,
            sync: true,
            //handleAs: "json",
            load: function(response, ioArgs) {
                console.log("response \n", response);
                var obj = dojo.fromJson(response);
                if (obj.result == 0) {
                    jsonstore = new dojo.data.ItemFileWriteStore({ data: obj.data });
                }
                fbfwca.ajax.responseHandler(obj);
                return response; //always return the response back
            },

            // Run this function if the request is not successful
            error: function(response, ioArgs) {
                console.log("failed xhrGet", response, ioArgs);
                fbfwca.ajax.errorHandler(response);
                return response; //always return the response back
            }
        });
        return jsonstore;
    },

    getJsonReadStore2: function(name, content) {
        console.log("servlet:" + fbfwca.ajax.AJAX_SERVLET);
        console.log("getJsonReadStore: ", name);
        var jsonstore;
        dojo.xhrGet({
            //	        url: fbfwca_getRoot()+ fbfwca.ajax.AJAX_SERVLET + "/" + name,  //the relative URL
            url: fbfwca.ajax.addRefreshSuffix(fbfwca_root + fbfwca.ajax.AJAX_SERVLET + "/" + name),  //the relative URL
            sync: true,
            content: content,
            load: function(response, ioArgs) {
                console.log("response \n", response);
                var obj = dojo.fromJson(response);
                console.log("result: " + obj.result);
                if (obj.result == 0) {
                    jsonstore = new dojo.data.ItemFileReadStore({ data: obj.data });
                }
                fbfwca.ajax.responseHandler(obj);
                return response; //always return the response back
            },

            // Run this function if the request is not successful
            error: function(response, ioArgs) {
                console.log("failed xhrGet", response, ioArgs);
                fbfwca.ajax.errorHandler(response);
                return response; //always return the response back
            }
        });
        return jsonstore;
    },

    getJsonObject2: function(name, content) {
        console.log("servlet:" + fbfwca.ajax.AJAX_SERVLET);
        console.log("getJsonWriteStore: ", name);
        var jsonObject = null;
        dojo.xhrGet({
            url: fbfwca.ajax.addRefreshSuffix(fbfwca_root + fbfwca.ajax.AJAX_SERVLET + "/" + name),  //the relative URL
            content: content,
            sync: true,
            load: function(response, ioArgs) {
                console.log("response \n", response);
                var obj = dojo.fromJson(response);
                if (obj.result == 0) {
                    jsonObject = obj.data;
                }
                fbfwca.ajax.responseHandler(obj);
                return response; //always return the response back
            },

            // Run this function if the request is not successful
            error: function(response, ioArgs) {
                console.log("failed xhrGet", response, ioArgs);
                fbfwca.ajax.errorHandler(response);
                return response; //always return the response back
            }
        });
        return jsonObject;
    },

    postJson: function(name, data) {
        var result = 0;  //assume success
        dojo.rawXhrPost({
            sync: true,
            //	        url: fbfwca_getRoot() + fbfwca.ajax.AJAX_SERVLET + "/" + name,
            url: fbfwca_root + fbfwca.ajax.AJAX_SERVLET + "/" + name,
            postData: dojo.toJson(data),
            load: function(response, ioArgs) {
                var obj = dojo.fromJson(response);
                result = obj.result;
                fbfwca.ajax.responseHandler(obj);
                return response;
            },
            error: function(response, ioArgs) {
                result = -1;
                console.log("failed xhrPost", response, ioArgs);
                fbfwca.ajax.errorHandler(response);
                return response; //always return the response back
            }
        });
        return result;
    },

    getAdminFolders: function() {
        return fbfwca.ajax.getJsonWriteStore("admin_folders");
    },

    getClients: function() {
        return fbfwca.ajax.getJsonWriteStore("clients");
    },

    getClientActivity: function(address) {
        return fbfwca.ajax.getJsonReadStore2("client/activity", { address: "" + address });
    },

    getClientConfiguration: function(address) {
        return fbfwca.ajax.getJsonObject2("client/configuration", { address: "" + address });
    },

    assignClientGroup: function(clients, group) {
        return fbfwca.ajax.postJson("clients?action=assign_group", { clients: clients, group: group });
    },


    getGroups: function() {
        return fbfwca.ajax.getJsonWriteStore("groups");
    },

    getGroupConfiguration: function(name) {
        return fbfwca.ajax.getJsonObject2("group/configuration", { name: "" + name });
    },

    addAdminFolder: function(name, address, group, script) {
        return fbfwca.ajax.postJson("admin_folders?action=create", { name: "" + name, address: "" + address, group: "" + group, script: "" + script });
    },

    modifyAdminFolder: function(name, address, group, script) {
        return fbfwca.ajax.postJson("admin_folders?action=modify", { name: "" + name, address: "" + address, group: "" + group, script: "" + script });
    },

    deleteAdminFolder: function(address) {
        return fbfwca.ajax.postJson("admin_folders?action=delete", { address: "" + address });
    },

    addGroup: function(group) {
        return fbfwca.ajax.postJson("groups?action=create", group);
    },

    modifyGroup: function(group) {
        return fbfwca.ajax.postJson("groups?action=modify", group);
    },



    deleteGroup: function(name) {
        return fbfwca.ajax.postJson("groups?action=delete", { name: "" + name });
    },


    getGroupMembers: function(name) {
        return fbfwca.ajax.getJsonWriteStore2("group/members", { name: "" + name });
    },

    getGroupSelectionList: function() {
	var NLS = dojo.i18n.getLocalization("nls", "general");
        var obj = fbfwca.ajax.getJsonObject("groups");
        obj.items.unshift({ name: NLS.T_None });
        return new dojo.data.ItemFileReadStore({ data: obj });
    },

    getScriptsSelectionList: function() {
	var NLS = dojo.i18n.getLocalization("nls", "general");
        var obj = fbfwca.ajax.getJsonObject("scripts");
        obj.items.unshift({ name: NLS.T_None });
        return new dojo.data.ItemFileReadStore({ data: obj });
    },

    getScriptsList: function() {
        var obj = fbfwca.ajax.getJsonObject("scripts");
        return new dojo.data.ItemFileReadStore({ data: obj });
    },

    createScript: function(script) {
        var i;
        for (i = 0; i < script.commands.length; i++) {
            script.commands[i] = escape(script.commands[i]);
        }
        return fbfwca.ajax.postJson("scripts?action=create", script);
    },

    modifyScript: function(script) {
        return fbfwca.ajax.postJson("scripts?action=modify", script);
    },

    deleteScript: function(name) {
        return fbfwca.ajax.postJson("scripts?action=delete", { name: "" + name });
    },

    sendScript: function(clients, name) {
        var obj = new Object();
        obj.scriptName = name;
        obj.clients = clients;
        return fbfwca.ajax.postJson("scripts?action=send", obj);
    },

    getScript: function(name) {
        return fbfwca.ajax.getJsonObject2("scripts", { name: "" + name });
    },

    getAuditArray: function(num) {
        return fbfwca.ajax.getJsonObject("audit?num=" + num);
    },

    getAlertTypes: function(num) {
        var obj = fbfwca.ajax.getJsonObject("alerts?action=types");
        var i;
        for (i = 0; i < obj.length; i++) {
            console.log(obj.items[i].name, " ", obj.items[i].type);
        }
    },

    createAlert: function(alertObj) {
        return fbfwca.ajax.postJson("alerts?action=create", alertObj);
    },

    deleteAlert: function(name) {
        return fbfwca.ajax.postJson("alerts?action=delete", { name: "" + name });
    },

    deleteAlertNotification: function(id) {
        return fbfwca.ajax.postJson("healthalerts?action=delete", { id: "" + id });
    },

    deleteAlertNotifications: function(alerts) {
        return fbfwca.ajax.postJson("healthalerts?action=delete_multi", { alerts: alerts });
    },

    modifyAlert: function(alertObj) {
        return fbfwca.ajax.postJson("alerts?action=modify", alertObj);
    },

    getAlert: function(name) {
        return fbfwca.ajax.getJsonObject2("alerts", { name: "" + name });
    },

    postMailServer: function(address, username, password, port) {
        var obj = new Object();
        obj.mail_server = address;
        obj.username = username;
        obj.password = password;
        obj.port = port;
        return fbfwca.ajax.postJson("mail?action=create", obj);
    },

    getMailAddresses: function() {
        return fbfwca.ajax.getJsonWriteStore("mail/addresses");
    },

    getMailServer: function() {
        return fbfwca.ajax.getJsonObject("mail");
    },

    getClientsHealthSummary: function() {
        return fbfwca.ajax.getJsonObject("clients/healthsummary");
    },

    generateConfigFile: function(address) {
        return fbfwca.ajax.getJsonObject2("admin_folder/configuration", { address: "" + address });
    },

    getSettings: function() {
        return fbfwca.ajax.getJsonObject("settings");
    },

    setSettings: function(obj) {
        return fbfwca.ajax.postJson("settings?action=create", obj);
    },

    deployPackage: function(clients, name) {
        var obj = new Object();
        obj.name = name;
        obj.clients = clients;
        return fbfwca.ajax.postJson("deployments?action=deploy", obj);
    },

    getDeploymentPackages: function() {
        var obj = fbfwca.ajax.getJsonObject("deployments");
        return new dojo.data.ItemFileReadStore({ data: obj });
    }
};

}
