/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableFooter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableFooter"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2008 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw", "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw");

dojo.provide("ibm.tivoli.tip.dijit.TIPTableFooter");
/******************************************************************************
* The footer for the TIP Table
*
* Authors: Joseph Firebaugh, Joshua Allen
******************************************************************************/
dojo.declare("ibm.tivoli.tip.dijit.TIPTableFooter",
            [ dijit._Widget, dijit._Templated ],
{
  widgetsInTemplate: true,

  templateString:"<table class=\"tip-table-footer-border\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\r\n\t<tbody>\r\n\t\t<tr class=\"tip-table-footer\">\r\n\t\t\t<td class=\"tip-table-footer-data\" nowrap=\"nowrap\" valign=\"middle\"> \r\n\t\t\t\t<div dojoAttachPoint=\"tableUpdateArea\" class=\"footerLabel\"></div>\r\n\t\t\t</td>\t\t\r\n\t\t\t<td class=\"tip-table-footer-data\" width=\"100%\" nowrap=\"nowrap\"> \r\n\t\t\t\t<div dojoType=\"dijit.Toolbar\" dojoAttachPoint=\"toolbar\" class=\"tableToolbarArea\" ></div>\r\n\t\t\t</td>\t\t\t\r\n\t\t\t<td class=\"tip-table-footer-data\" nowrap=\"nowrap\" valign=\"middle\"> \r\n\t\t\t\t<div dojoAttachPoint=\"infoArea\" class=\"footerLabel\"></div>\r\n\t\t\t</td>\r\n\t\t</tr>  \r\n\t</tbody>\r\n</table>\r\n",
  
  //the dojox.Grid that this footer belongs to
  table: null,
  
  constructor: function () 
  {
    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");    
  },
  
  postCreate: function()
  {
    if ( this.table !== null )
    {
      this.setTable( this.table );
    }        
  },
  
  setTable: function( table )
  {
    this.table = table;
    
    this._rowClickListener = dojo.connect( this.table, "onRowClick", this, "_onRowClick");            
    this._updateListener   = dojo.connect( this.table, "setModel",   this, "_onRowClick" );            
    
  },
  
  getToolbar: function () 
  {
  	return (this.toolbar);
  },
  
  _onRowClick: function()
  {      
    var numSelected = 0;
    var totalRows   = 0;
    
    if ( this.table.model )
    {
		if (this.table.model.getRealRowCount) {
			totalRows = this.table.model.getRealRowCount();
		} else {
			totalRows = this.table.model.getRowCount();
		}
    }

    numSelected = this.table.selection.getSelectedCount();
    
    this.updateFooter( numSelected, totalRows );
  },
    
  updateFooter: function( numSelected, totalRows )
  {
    this.setInfoAreaHTML( dojo.string.substitute( this.resources_.TABLE_FOOTER_TEXT, { 0: numSelected, 1: totalRows } ) );  
  },
  
  setInfoAreaHTML: function ( html )
  {
	//jfirebau
	//To fix some race conditions with creating and destroying TIPTables I need
	//to check for the existence of the infoArea before setting content
    if( this.infoArea )
    {
    	this.infoArea.innerHTML = html;    	
    }	
  },
  
  setTableUpdateAreaHTML: function ( html )
  {
	this.tableUpdateArea.innerHTML = html;
  },  
  
  destroy: function()
  {
  	//fix defect 248535
	this.inherited( "destroy", arguments );
    if ( this._rowClickListener ) { dojo.disconnect( this._rowClickListener ); }
    if ( this._updateListener )   { dojo.disconnect( this._updateListener ); }
    //Fix for defect 150409 on bug tracker on CS. Toolbar destroy is called twice throws error on IE
    //if(this.toolbar){
    //	this.toolbar.destroy();
    //}
  }  
});

}
