/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableOptions"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableOptions"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.tivoli.tip.dijit.TIPTableOptions");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit.form.CheckBox");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw", "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw");


// define the widget class
dojo.declare (
	"ibm.tivoli.tip.dijit.TIPTableOptions", 
    [ dijit._Widget, dijit._Container ],
{
    table: null,

	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
	    console.info ("enter TIPTableOptions.constructor");
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		console.info ("enter TIPTableOptions:postCreate");
		this.addColumnsVisible (this.table.originalStructure.cells);
	},
	addColumnsVisible: function (columns) {
		console.info ("enter TIPTableOptions.addColumnsVisible");
		var widget = null;
		var column = null;

		for (var i in columns) {
			if (i) {
				column = columns[i];
				console.log ("got column i: ");
				console.log (column);
				if (column.name) {
					widget = new ibm.tivoli.tip.dijit.ColumnVisible ({
						id: this.id + "column_" + column.field,
						columnid: this.id + "column_" + column.field,
						baseid: column.field,
						checked: column.visible===undefined?!column.hidden:column.visible,  
						label: column.name
					});
					this.addChild (widget);
					console.log ("added column widget");
				} else {
					console.log ("this column was created internally by data store.  do not show it.");
				}
			}
		}		

		console.info ("exit TIPTableOptions.addColumnsVisible");
	},
	
	// add on2009/07/07 by chujing for function selectall
	
	onSelectAll: function(){
		
	var columns = this.table.originalStructure.cells;	 
		for (var i in columns) {
			if (i) {
				var columnWidget = dijit.byId (this.id + "column_" + columns[i].field);
				columnWidget.setVisible(true);	 
			}
		}
		
	},
	// add on2009/07/07 by chujing for function deselectall
	onDeselectAll:function (){
    var columns = this.table.originalStructure.cells;
		 
		for (var i in columns) {
			if (i) {
				var columnWidget = dijit.byId (this.id + "column_" + columns[i].field);
				columnWidget.setVisible(false);	 
			}
		}

	},
	onSave: function () {
		var columns = this.table.originalStructure.cells;
		var allColumns = [];
	
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				var columnWidget = dijit.byId (this.id + "column_" + column.field);
				var tblColumn = this.table.getColumnById (column.field);
				column.visible = columnWidget.isVisible();
				columns[i].visible=columnWidget.isVisible();//added at 2009/04/24 for function show/hidden column
				console.log ("setting column: " + column.field + " to visible: " + column.visible);

				if (tblColumn) {
					// In order to preserve the column width, we need to set the width property
					tblColumn.width = tblColumn.unitWidth;
					// set these values on the originalStruture so they will be in memory
					// in case the dialog is opened again
					column.width = tblColumn.unitWidth;
				} else {
					tblColumn = column;
				}
				
				this.table.grid.layout.setColumnVisibility(i, columnWidget.isVisible());

				console.log ("TIPTableOptions.onSave. pushing column: ");
				console.log (column);
				allColumns.push (column);
			}
		}
	
		//this.table.savePreferences();
		this.table.originalStructure.cells = allColumns;
		console.log ("exit TIPTableOptions.onSave with originalStructure: ");
		console.log (this.table.originalStructure);
	},
	isColumnVisible: function (columnID) {
		var columnWidget = dijit.byId (this.id + "column_" + columnID);
		return (columnWidget.isVisible());
	}
	
});


// define the widget class
dojo.declare (
	"ibm.tivoli.tip.dijit.ColumnVisible", 
    [ dijit._Widget, dijit._Templated ],
{
	columnid: null,
	label: null,
	checked: false,
	widgetsInTemplate: true,
	templateString:"<div>\r\n\t<input dojoType=\"dijit.form.CheckBox\" dojoAttachPoint=\"checkbox\" name=\"${columnid}CB\" id=\"${columnid}CB\" value=\"\" />\r\n\t\t&nbsp;\r\n\t<label for=\"${columnid}CB\">${label}</label>\r\n</div>\r\n",
	
	constructor: function () {
		console.log ("enter ColumnsVisible.constructor");
	},
	postCreate: function () {
		console.log ("enter ColumnVisible.postCreate");
		if (this.checked) {
			this.checkbox.setChecked (this.checked);
		}
		console.log ("exit ColumnVisible.postCreate");
	},
	setVisible: function (checked) {
		this.checkbox.setChecked (checked);
	},
	isVisible: function () {
		return this.checkbox.checked;
	},
	destroy: function () {
		console.log ("enter ColumnVisible.destroy for");
		console.log (this);
		this.inherited (arguments);
		console.log ("exit ColumnVisible.destroy");
	}
	
});


}
