/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPViewChanger"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPViewChanger"] = true;
	/******************************************************* {COPYRIGHT-TOP-OCO} ***
	 * Licensed Materials - Property of IBM
	 *
	 * (C) Copyright IBM Corp. 2008 All Rights Reserved.
	 *
	 * US Government Users Restricted Rights - Use, duplication, or
	 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
	 ******************************************************* {COPYRIGHT-END-OCO} ***/
	dojo.require("dijit.Toolbar");
	dojo.require("dijit.Menu");
	dojo.require("dijit.form.Button");
	dojo.require("dijit.layout.LayoutContainer");
	dojo.require("dijit.layout.ContentPane" );
	
	dojo.provide("ibm.tivoli.tip.dijit.TIPViewChanger");
	/****************************************************************************
	* View Changer Widget
	*    This widget is responsible for providing a toolbar with a dropdown 
	*    button that allows for changing views beneath the toolbar.  It's kinda
	*    like a card layout, in which views are context switched based on the
	*    dropdown selection.
	*
	*    In addition, each view can contribute toolbar icons when inacted.
	*
	* Proud author: Joseph Firebaugh
	****************************************************************************/
	dojo.declare("ibm.tivoli.tip.dijit.TIPViewChanger",
	              dijit.layout.LayoutContainer,
	{
	  viewNames:     [ "viewNames not set" ],
	  viewTooltips:  [ "viewTooltips not set" ],
	  viewIconClass: null,
	  
	  defaultView: 0,
	  	
	  /****************************************************************************
	  * PostCreate
	  *    this method is called after dojo builds the DOM node for this widget
	  *    we will build the contents of this widget programatically.
	  ****************************************************************************/
	  postCreate: function() 
	  {
	    this.inherited( arguments );
		
		//****************************************
	    //* create the toolbar area for the 
	    //* drop down button view changer
	    //****************************************	
	    var div = dojo.doc.createElement('div');
	    this.viewChangerToolbar = new dijit.Toolbar( { layoutAlign: 'top' }, div );
	    this.addChild( this.viewChangerToolbar );
	    
	    this.dropDownMenu = new dijit.Menu({});
	    this.dropDownMenu.domNode.style.display="none";  
	    //****************************************
	    //* create the dropdown menu for the 
	    //* change view button from all view names
	    //****************************************
	    this.menuItems = [];
	    var params = null;
	    for ( var i = 0; i < this.viewNames.length; i++ )
	    {
		    params = {
		    	label: this.viewNames[i],
		    	onClick: dojo.hitch( this, "changeView", i )
		    };    
		    
		    if ( this.viewIconClass !== null )
		    {
		    	params.iconClass = this.viewIconClass + i;
		    }	    
		    
		    this.menuItems[i] = new dijit.MenuItem( params );
		    this.dropDownMenu.addChild( this.menuItems[i] );
	    }
	    
	    //****************************************
	    //* Add the drop down button
	    //****************************************
	    div = dojo.doc.createElement('div');
	    params = {
	    	title: this.viewTooltips[ this.defaultView ],
	    	label: this.viewNames[ this.defaultView ],
	    	id: this.id + "viewChangeBtn",
	    	dropDown: this.dropDownMenu    	
	    };
	      
	    this.viewChangeBtn = new dijit.form.DropDownButton( params, div );
	    
	  	this.viewChangeBtn.containerNode.style.fontFamily = "Verdana,Arial,Helvetica,sans-serif";
	  	this.viewChangeBtn.containerNode.style.fontSize   = "1em";
	    
	    this.viewChangerToolbar.addChild( this.viewChangeBtn ); 
	        
	    setTimeout( dojo.hitch( this, "changeView", this.defaultView ), 500 );  
	  },
	  
	  /****************************************************************************
	  * changeView
	  *    this method is called when a user choses a view to display from the
	  *    drop down button's context menu.  The index of the view is passed in
	  ****************************************************************************/
	  changeView: function( viewNum )
	  {
	  	//this changes the label on the drop down button so that the current 
	  	//visible view is the button label -- serving as a "title" of the view
	  	//artificually adding a space between label and icon for better appearances
	  	this.viewChangeBtn.setLabel( "&nbsp;" + this.viewNames[ viewNum ] );
		
		//remove the icon off the button so that it can be replaced with the next view icon
		if ( this.lastIconClass )
		{
	  		dojo.removeClass( this.viewChangeBtn.iconNode, this.lastIconClass );
		}
		
	  	var iconClass;
		if ( this.viewIconClass !== null )
		{
		  iconClass = this.viewIconClass + viewNum;
	
	  	  //add the CSS style to the button for the new icon
	  	  dojo.addClass( this.viewChangeBtn.iconNode, iconClass );
	  	  
	  	  //save a reference to the icon to be removed later if view changes
	  	  this.lastIconClass = iconClass;
		}	    
	  	
	  	//if a view is currently visible then destroy it now.
	  	if ( this.currentView )
	  	{
	  		try
	  		{
	  			this.removeChild( this.currentView );
	  			this.viewRemoved( this.currentView );
	  		}
	  		catch( e )
	  		{
	  			console.debug( e );
	  		}
	  	}
	  	  	
	    this.currentView = this.getViewWidget( viewNum );
	    
	    this.currentView.layoutAlign = "client";  	
	    
	    //record the index of the new view for eventing lookup
	    this.currentViewNum = viewNum;
	        
	    //add the new view to the layout container
	   	this.addChild( this.currentView );
	   	   	
	   	//add toolbar contributions from new view
	   	if ( this.currentView.contributeToolbarItems )
	   	{
	   	  this.currentView.contributeToolbarItems( this.viewChangerToolbar );			        	
	   	}	
	  },
	  
	  /****************************************************************************
	  * getViewWidget
	  *    this method should be overloaded by the using application to provide
	  *    each toggled view.  Preferrably this view widget will extend ContentPane
	  ****************************************************************************/
	  getViewWidget: function( viewNum ){ return new dijit.layout.ContentPane(); },
	  
	  /****************************************************************************
	  * viewRemoved
	  *    this method should be overloaded by the using application if you wish 
	  *    to destroy each view as they are removed.  
	  ****************************************************************************/
	  viewRemoved: function( viewWidget ){},
	
	  /****************************************************************************
	  * destroy
	  *    A well designed widget must implement a destroy method to clean up
	  *    anything necessary
	  ****************************************************************************/
	  destroy: function() 
	  {
	     if ( this.currentView )
	     {
	     	this.currentView.destroy();
	     }
	     
	     for ( var i in this.menuItems )
	     {
	     	if (i) {
	     		this.menuItems[ i ].destroy();
	     	}
	     }
	     
	     this.dropDownMenu.destroy();
	     this.viewChangeBtn.destroy();
	     this.viewChangerToolbar.destroy();
	     
	     this.inherited( "destroy", arguments );
	  }
	});

}
