/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPWizardV2"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPWizardV2"] = true;
dojo.provide("ibm.tivoli.tip.dijit.TIPWizardV2");
dojo.provide("ibm.tivoli.tip.dijit.TIPWizardV2Page");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.StackContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.Button");
dojo.require("dijit.form._FormMixin");
dojo.require("dojo.i18n");
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw", "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw");

/*
 * Createing a TIPWizardV2 in markup
 * <div id="wiz" dojoType="ibm.tivoli.tip.dijit.TIPWizardV2" mode="wizard">
 *		<div dojoType="ibm.tivoli.tip.dijit.widget_wiz.Welcome"></div>
 *		<div dojoType="ibm.tivoli.tip.dijit.widget_wiz.BaseWidget"></div>
 *		<div dojoType="ibm.tivoli.tip.dijit.widget_wiz.General"></div>
 *		<div dojoType="ibm.tivoli.tip.dijit.widget_wiz.Security"></div>
 *		<div dojoType="ibm.tivoli.tip.dijit.widget_wiz.Summary" ></div>
 *	</div>
 *  * 
 * Attributes:
 * 	mode: "wizard" or "notebook" determines the style of UI
 * 
 * Events:
 *	OnPageSelected: when a page is made active
 *	OnBack: when the Back button is clicked
 *	OnNext: when the Next button is clicked
 *	OnOK: when the Finish/OK button is clicked
 *	OnApply: when the Apply button is clicked
 *	OnCancel: when the Cancel button is clicked
 */
dojo.declare("ibm.tivoli.tip.dijit.TIPWizardV2", [dijit._Widget, dijit._Templated, dijit._Container],
{
	widgetsInTemplate: true,
	templateString:"<div class=\"tip-wiz\">\r\n\t<div dojoType=\"dijit.layout.BorderContainer\" design=\"headline\" gutters=\"false\" class=\"tip-wiz-outer\" dojoAttachPoint=\"_outerContainer\">\r\n\t\t<div dojoType=\"dijit.layout.BorderContainer\" gutters=\"false\" liveSplitters=\"false\" design=\"sidebar\" region=\"center\" style=\"width:100%;height:100%;\">\r\n\t\t\t<div dojoType=\"dijit.layout.ContentPane\" region=\"leading\" splitter=\"false\" class=\"tip-wiz-toc\">\r\n\t\t\t\t<ol dojoAttachPoint=\"_toc\"></ol>\r\n\t\t\t</div>\r\n\t\t\t<div dojoType=\"dijit.layout.StackContainer\" region=\"center\" splitter=\"false\" dojoAttachPoint=\"_pageContainer\" class=\"tip-wiz-work-area\">\r\n\t\t\t\t<form id=\"${id}_form\" dojoAttachPoint=\"containerNode\" action=\"${action}\" method=\"${method}\"></form>\t\t\t\t\t\t\t\r\n\t\t\t</div>\r\n\t\t</div>\r\n\t\t<div dojoType=\"dijit.layout.ContentPane\" region=\"bottom\" splitter=\"false\" class=\"tip-wiz-footer\">\r\n\t\t\t<button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickBack\" dojoAttachPoint=\"_backButton\">${backLabel}</button>\r\n\t\t\t<button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickNext\" dojoAttachPoint=\"_nextButton\">${nextLabel}</button>\r\n\t\t\t<button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickFinish\" dojoAttachPoint=\"_finishButton\">${finishLabel}</button>\r\n\t\t\t<button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickApply\" dojoAttachPoint=\"_applyButton\" class=\"dijitHidden\">${applyLabel}</button>\r\n\t\t\t<button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickCancel\" dojoAttachPoint=\"_cancelButton\">${cancelLabel}</button>\r\n\t\t</div>\r\n\t</div>\r\n</div>\r\n",
	mode: "w", 				// "wizard" or "notebook" (actually, anything starting with "w" | "n"),
	action: ".", 			// the action attribute on the contained <form>
	method: "POST",			// the method attribute on the contained <form>
	backLabel: "",
	nextLabel: "",
	finishLabel: "",
	applyLabel: "",
	cancelLabel: "",
	_pages: [],
	_pageChangeConnections: {},
	_containerSubscriptions: [],
	_origOK: null,
	_origApply: null,
	
	constructor: function()
	{
		this._origOK = this.OnOK;
		this._origApply = this.OnApply;
	},
	postMixInProperties: function()
	{
		if(this.mode && this.mode.length > 0)
			this.mode = this.mode.charAt(0).toLowerCase();
		var string_table = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
		this.backLabel = string_table.BACK;
		this.nextLabel = string_table.NEXT;
		this.finishLabel = 'w' == this.mode ? string_table.FINISH : string_table.OK;
		this.applyLabel = string_table.APPLY;
		this.cancelLabel = string_table.CANCEL;
		this.inherited(arguments);
	},
	buildRendering: function()
	{
		console.log("TIPWizardV2.buildRendering");

		this.inherited(arguments);
		this._pageContainer.containerNode = this.containerNode;
		if('w' === this.mode) {
			dojo.addClass(this.domNode, "tip-wiz-wizard");
		}
		else {
			dojo.addClass(this.domNode, "tip-wiz-notebook");
			dojo.removeClass(this._applyButton.domNode, "dijitHidden");
			dojo.addClass(this._backButton.domNode, "dijitHidden");
			dojo.addClass(this._nextButton.domNode, "dijitHidden");
		}
		console.log("rendered");
	},
	postCreate: function()
	{
		console.log("TIPWizardV2.postCreate");
		this.inherited(arguments);
	},
	startup: function()
	{
		if(this._started){ return; }
		console.log("TIPWizardV2.startup");
		this.inherited(arguments);
		
		this._containerSubscriptions.push(dojo.subscribe(this._pageContainer.id + "-selectChild", this, this._onPageSelected));
		this._containerSubscriptions.push(dojo.subscribe(this._pageContainer.id + "-addChild", this, this._onPageAdded));
		this._containerSubscriptions.push(dojo.subscribe(this._pageContainer.id + "-removeChild", this, this._onPageRemoved));

		// build the initial table of contents from the pages provided in markup
		this._pages = this._pageContainer.getChildren();
		this._buildToC();

		// This is copied from StackContainer.startup, which gets called too soon

		// Setup each page
		dojo.forEach(this._pages, this._pageContainer._setupChild, this._pageContainer);
		dojo.forEach(this._pages, function(p, i) {
			this._onPageAdded(p, i)
		}, this);
		
		var selectedChild = null;
		dojo.some(this._pages, function(child){
			if(child.selected){
				selectedChild = child;
			}
			return child.selected;
		}, this);
		if(!selectedChild && this._pages[0]){
			selectedChild = this._pages[0];
		}
		if(selectedChild) {
	    //The _onPageSelected function wasn't getting called for a selectPage
			//this.selectPage(selectedChild);
	    this._onPageSelected(selectedChild);
		}
		
		this._outerContainer.resize();
	},
	/**
	 * submit the contained form
	 * wire this function to the OnOK event
	 */
	submit: function(wiz)
	{
		// our form is the containerNode
		var f;
		switch(this.method.toLowerCase()) {
		case "get":
			f = dojo.xhrGet;
			break;
		case "post":
			f = dojo.xhrPost;
			break;
		case "put":
			f = dojo.xhrPut;
			break;
		default:
			f = dojo.xhrPost;
		}
		var dfd = f({
			url: this.action,
			preventCache: true,
			form: this.id + "_form", 
			load: function(response) {
				console.log("TIPWizardV2.submit success");
			},
			error: function(response) {
				console.error("TIPWizardV2.submit failure");
				console.error(response);
			}
		});
		return dfd;
	},
	_buildToC: function()
	{
		console.log("TIPWizardV2._buildToC");
		
		while(this._toc.firstChild) {
			this._toc.removeChild(this._toc.firstChild);
		}
		
		var page_count = this._pages.length;
		dojo.forEach(this._pages, function(p, i) {
			var toc_item = p.buildTOCRendring();
			dojo.place(toc_item, this._toc, "last");
			if("n" === this.mode) {
				this.connect(toc_item, "onclick", this._onToCClick);
				this.connect(toc_item, "onmouseover", dojo.hitch(this, this._onToCOver));
				this.connect(toc_item, "onmouseout", dojo.hitch(this, this._onToCOut));
			}
		}, this);
	},
	destroy: function()
	{
		console.log("TIPWizardV2.destroy");
		var alerter;
		while(alerter = this._containerSubscriptions.pop()) {
			dojo.unsubscribe(alerter);
		}
		var p;
		for(p in this._pageChangeConnections) {
			dojo.disconnect(this._pageChangeConnections[p]);
		}
		this.inherited(arguments);
	},
	destroyRecursive: function()
	{
		console.log("TIPWizardV2.destroyRecursive");
		this.inherited(arguments);
	},
	selectPage: function(/*widget or id*/ p)
	{
		this._pageContainer.selectChild(p);
	},
	addPage: function(/*widget*/ p)
	{
		this._pageContainer.addChild(p);
		this._pages = this._pageContainer.getChildren();
		this._buildToC();
		this.updateUI();
	}, 
	removePage: function(/*widget or id*/ p)
	{
		// TODO: if removing selected page, select something else
		// (or does StackContainer do that for me?)
		p = dijit.byId(p);
		this._pageContainer.removeChild(p);
		this._pages = this._pageContainer.getChildren();
		this._buildToC();
		this.updateUI();
	}, 
	updateUI: function()
	{
		console.log("TIPWizardV2.updateUI");
		
		var curr_page = this._pageContainer.selectedChildWidget;
		var page_count = this._pages.length;
		
		// disable the Back/Next buttons if we are on the first/last page
		var isFirst = true, isLast = true;
		if(page_count > 0) {
			isFirst = curr_page === this._pages[0];
			isLast =  curr_page === this._pages[this._pages.length-1];
		}
		this._backButton.attr("disabled", isFirst);
		this._nextButton.attr("disabled", isLast);
		
		var isCurrentPageValid = curr_page && curr_page.isValid(); 
		
		// disable the Next and Apply buttons if the selected page does not validate
		if( !isCurrentPageValid ) {
			this._nextButton.attr("disabled", true);
			this._applyButton.attr("disabled", true);
		}
		// disable the Finish/OK button until all pages are valid
		var allValid = dojo.every(this._pages, function(p){
			var v = p.isValid();
			if("w" == this.mode)
				v = v && (p.visited || p === curr_page);
			return v;
 		}, this);
		this._finishButton.attr("disabled", !allValid);
		this._applyButton.attr("disabled", !allValid);
		
		// update the ToC
		dojo.query("li[pageID]", this._toc).forEach(function(n, i) {
			var pid = dojo.attr(n, "pageID");
			var p = dijit.byId(pid);
			dojo[(p && p.visited) ? "addClass" : "removeClass"](n, "tip-wiz-visited");
			dojo[(p && (!p.visited || p.validated)) ? "removeClass" : "addClass"](n, "tip-wiz-invalid");
			dojo[(p == curr_page) ? "addClass" : "removeClass"](n, "tip-wiz-selected");
		});
		//To make the current page visible
		if(curr_page){
			dojo.removeClass(curr_page.domNode,"dijitHidden");
			dojo.addClass(curr_page.domNode,"dijitVisible");
		}
	},
	_onPageSelected: function(page) 
	{
		console.log("TIPWizardV2._onPageSelected: " + page.id);
		
		if('n' == this.mode) {
			page.visited = true;
		}
		
		this.OnPageSelected(this, page);
		if("function" == typeof page.OnPageSelected) {
			page.OnPageSelected(this);
		}
		this.updateUI();
	},
	_onPageContentChange: function(page)
	{
		console.log("TIPWizardV2.onPageContentChange: " + page.title);
		this.updateUI();
	},
	_onPageAdded: function(page, insertIndex)
	{
		console.log("TIPWizardV2._onPageAdded: " + page.id + " pos: " + insertIndex);
		page.attr("wizard", this);
		this._pageChangeConnections[page.id] = dojo.connect(page, "OnPageContentChange", this, this._onPageContentChange);
		this.updateUI();
	},
	_onPageRemoved: function(page)
	{
		console.log("TIPWizardV2._onPageRemoved: " + page.id);
		dojo.disconnect(this._pageConnections[page.id]);
		delete _pageChangeConnections[page.id];
		this.updateUI();
	},
	_onToCOver: function(evt)
	{
		var li = evt.target;
		while(null != li && li.tagName.toLowerCase() != "li") {
			li = li.parentNode;
		}
		if(null == li) return;
		dojo.addClass(li, "over");
	},
	_onToCOut: function(evt)
	{
		var li = evt.target;
		while(null != li && li.tagName.toLowerCase() != "li") {
			li = li.parentNode;
		}
		if(null == li) return;
		dojo.removeClass(li, "over");		
	},
	_onToCClick: function(evt)
	{
		var li = evt.target;
		while(null != li && li.tagName.toLowerCase() != "li") {
			li = li.parentNode;
		}
		if(null == li) return;
		var pid = dojo.attr(li, "pageID");
		if(null != pid) {
			this.selectPage(pid);
		}
	},
	_onClickBack: function(evt)
	{
		this._pageContainer.back();
		this._pageContainer.selectedChildWidget.visited = false;
		this.updateUI();
		this.OnBack(this);
	},
	_onClickNext: function(evt)
	{
		this._pageContainer.selectedChildWidget.visited = true;
		this._pageContainer.forward();
		this.updateUI();
		this.OnNext(this);
	},
	_onClickFinish: function(evt)
	{
		console.log("TIPWizardV2._onClickFinish");
		this.OnOK(this);
	},
	_onClickApply: function(evt)
	{
		console.log("TIPWizardV2._onClickApply");
		this.OnApply(this);
	},
	_onClickCancel: function(evt)
	{
		console.log("TIPWizardV2._onClickCancel");
		this.OnCancel(this);
	},
	// fired events
	OnPageSelected: function(wiz, page)
	{
		// override or connect to me
	},
	OnBack: function(wiz)
	{
		// override or connect to me
	},
	OnNext: function(wiz)
	{
		// override or connect to me
	},
	OnOK: function(wiz)
	{
		// override or connect to me
		
		// if this is still the same function as it was originally,
		// then nobody has connected to the event. do the default
		if(this._origOK === this.OnOK) {
			// nothing connected, do the default
			this.submit(this);
		}
	},
	OnApply: function(wiz)
	{
		// override or connect to me
		
		// if this is still the same function as it was originally,
		// then nobody has connected to the event. do the default
		if(this._origApply === this.OnApply) {
			// nothing connected, do the default
			this.submit(this);
		}
	},
	OnCancel: function(wiz)
	{
		// override or connect to me
	}
});

/**
 * A wizard page
 * TODO: when we implement advanced wizard navigation, like sub-tasks, sub-class TIPWizardV2Page and
 *			override buildTOCRendering.
 * TODO: add event handling so the parent page of sub-tasks can advance the wizard to the first sub-task
 * 			when it gets selected
 */
dojo.declare("ibm.tivoli.tip.dijit.TIPWizardV2Page", [dijit.layout.ContentPane, dijit._Templated, dijit.form._FormMixin], 
{
	widgetsInTemplate: true,
	title: "",
	visited: false,				// has this page been visited?
	validated: false,			// has this page been validated?
			
	// render the page itself
	buildRendering: function()
	{
		console.log("TIPWizardV2Page.buildRendering");
		this.inherited(arguments);
		
		// TIPWizardV2Page subclasses ContentPane, but adds in _Templated, which ContentPane didn't expect
		// we have to fix some stuff.
		dojo.attr(this.domNode, "region", "center");
		this.containerNode = this.domNode;
		dojo.addClass(this.domNode, "tip-wiz-page");
	},
	// render this page's entry in the ToC
	buildTOCRendring: function()
	{
		var li = dojo.create("li", {
					innerHTML: "<div class='tip-wiz-toc-icon'></div><div>" + this.title + "</div>",
					pageID: this.id,
					className: this.visited ? "tip-wiz-visited" : "" 
		});
		return li;
	},
	// dijit.form._FormMixin will walk through all the child widgets checking their validity,
	// if you need to do something else, override
	isValid: function()
	{
		this.validated = this.inherited(arguments); 
		console.log(this.title + ".isValid <= " + this.validated);
		return this.validated;
	},
	// same as isValid, but moves focus to the first invalid child widget
	validate: function()
	{
		this.validated = this.inherited(arguments);
		console.log(this.title + ".validate <= " + this.validated);
		return this.validated;
	},
	OnPageSelected: function(wiz)
	{
		// override or connect to me
	},
	// catch OnChange events from my child widgets,
	// then let listeners know something's changed
	_onPageContentChange: function(evt)
	{
		this.OnPageContentChange(this);
	},
	OnPageContentChange: function(page)
	{
		// override or connect to me
	}
});

}
